Package com.smartgwt.client.tools

# Class EditTree

java.lang.Object
com.google.gwt.user.client.ui.UIObject
com.google.gwt.user.client.ui.Widget
com.smartgwt.client.widgets.BaseWidget
com.smartgwt.client.widgets.Canvas
com.smartgwt.client.widgets.layout.Layout
com.smartgwt.client.widgets.layout.VLayout
com.smartgwt.client.widgets.grid.ListGrid
com.smartgwt.client.widgets.tree.TreeGrid
com.smartgwt.client.tools.EditTree

All Implemented Interfaces:
  `HasAttachHandlers`, `HasHandlers`, `EventListener`, `HasVisibility`, `IsWidget`, `LogicalStructure`, `DataBoundComponent`, `HasClearHandlers`, `HasClickHandlers`, `HasDoubleClickHandlers`, `HasDragCompleteHandlers`, `HasDragMoveHandlers`, `HasDragRepositionMoveHandlers`, `HasDragRepositionStartHandlers`, `HasDragRepositionStopHandlers`, `HasDragResizeMoveHandlers`, `HasDragResizeStartHandlers`, `HasDragResizeStopHandlers`, `HasDragStartHandlers`, `HasDragStopHandlers`, `HasDropCompleteHandlers`, `HasDropHandlers`, `HasDropMoveHandlers`, `HasDropOutHandlers`, `HasDropOverHandlers`, `HasFetchDataHandlers`, `HasFocusChangedHandlers`, `HasFormulaUpdatedHandlers`, `HasHoverHandlers`, `HasHoverHiddenHandlers`, `HasKeyDownHandlers`, `HasKeyPressHandlers`, `HasMouseDownHandlers`, `HasMouseMoveHandlers`, `HasMouseOutHandlers`, `HasMouseOverHandlers`, `HasMouseStillDownHandlers`, `HasMouseUpHandlers`, `HasMouseWheelHandlers`, `HasMovedHandlers`, `HasParentMovedHandlers`, `HasResizedHandlers`, `HasRightMouseDownHandlers`, `HasRuleContextChangedHandlers`, `HasScrolledHandlers`, `HasShowContextMenuHandlers`, `HasVisibilityChangedHandlers`, `HasBodyKeyPressHandlers`, `HasCellClickHandlers`, `HasCellContextClickHandlers`, `HasCellDoubleClickHandlers`, `HasCellErrorIconHoverHandlers`, `HasCellErrorIconOutHandlers`, `HasCellErrorIconOverHandlers`, `HasCellHoverHandlers`, `HasCellMouseDownHandlers`, `HasCellMouseUpHandlers`, `HasCellOutHandlers`, `HasCellOverHandlers`, `HasCellSavedHandlers`, `HasCellSelectionChangedHandlers`, `HasCellValueHoverHandlers`, `HasCriteriaChangedHandlers`, `HasDataArrivedHandlers`, `HasDataChangedHandlers`, `HasDrawAreaChangedHandlers`, `HasEditCompleteHandlers`, `HasEditFailedHandlers`, `HasEditorEnterHandlers`, `HasEditorExitHandlers`, `HasFieldStateChangedHandlers`, `HasFilterEditorSubmitHandlers`, `HasGroupByCompleteHandlers`, `HasGroupByHandlers`, `HasGroupStateChangedHandlers`, `HasGroupTreeChangedHandlers`, `HasHeaderClickHandlers`, `HasHeaderDoubleClickHandlers`, `HasHeaderHoverHandlers`, `HasHilitesChangedHandlers`, `HasRecordClickHandlers`, `HasRecordCollapseHandlers`, `HasRecordDoubleClickHandlers`, `HasRecordDropHandlers`, `HasRecordExpandHandlers`, `HasRegroupHandlers`, `HasRemoveRecordClickHandlers`, `HasRowContextClickHandlers`, `HasRowEditorEnterHandlers`, `HasRowEditorExitHandlers`, `HasRowHoverHandlers`, `HasRowMouseDownHandlers`, `HasRowMouseUpHandlers`, `HasRowOutHandlers`, `HasRowOverHandlers`, `HasSelectionChangedHandlers`, `HasSelectionUpdatedHandlers`, `HasSetSortHandlers`, `HasSortChangedHandlers`, `HasSorterClickHandlers`, `HasSorterContextClickHandlers`, `HasViewStateChangedHandlers`, `HasMembersChangedHandlers`, `HasDataArrivedHandlers`, `HasDataChangedHandlers`, `HasFolderClickHandlers`, `HasFolderClosedHandlers`, `HasFolderContextClickHandlers`, `HasFolderDropHandlers`, `HasFolderOpenedHandlers`, `HasLeafClickHandlers`, `HasLeafContextClickHandlers`, `HasNodeClickHandlers`, `HasNodeContextClickHandlers`

public class EditTree extends TreeGrid
A TreeGrid that allows drag and drop creation and manipulation of a tree of objects described by DataSources.

Nodes can be added via drag and drop from a `Palette` or may be programmatically added via `addNode()`. Nodes may be dragged within the tree to reparent them.

Eligibility to be dropped on any given node is determined by inspecting the DataSource of the parent node. Drop is allowed only if the parent schema has a field which accepts the type of the dropped node.

On successful drop, the newly created component will be added to the parent node under the detected field. Array fields, declared by setting `dataSourceField.multiple:true`, are supported.

An EditTree is initialized by setting `rootComponent` or `editContext`. EditTree.data (the Tree instance) should never be directly set or looked at.

EditTree automatically creates an `EditContext` and provides several APIs and settings that are passthroughs to the underlying EditContext for convenience.

See Also:
  - `Dashboards & Tools Framework Overview`

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

  `UIObject.DebugIdImpl, UIObject.DebugIdImplEnabled`

- ## Field Summary

  ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

  `config, configOnly, factoryCreated, factoryProperties, id, nativeObject, scClassName`

  ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

  `DEBUG_ID_PREFIX`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `EditTree()`
  `EditTree(JavaScriptObject jsObj)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `EditNode`
  `addFromPaletteNode(PaletteNode paletteNode)`
  Creates a new EditNode from a PaletteNode, using the `defaultPalette`.
  `EditNode`
  `addFromPaletteNode(PaletteNode paletteNode, EditNode parentNode)`
  Creates a new EditNode from a PaletteNode, using the `defaultPalette`.
  `EditNode[]`
  `addFromPaletteNodes(PaletteNode[] paletteNodes)`
  Add the supplied `PaletteNodes` to the parentNode, preserving internal references from one supplied PaletteNode to another.
  `EditNode[]`
  `addFromPaletteNodes(PaletteNode[] paletteNodes, EditNode parentNode)`
  Add the supplied `PaletteNodes` to the parentNode, preserving internal references from one supplied PaletteNode to another.
  `EditNode`
  `addNode(EditNode newNode)`
  Add a new `EditNode` to the EditContext, under the specified parent.
  `EditNode`
  `addNode(EditNode newNode, EditNode parentNode)`
  See `addNode()`
  `EditNode`
  `addNode(EditNode newNode, EditNode parentNode, Integer index)`
  See `addNode()`
  `EditNode`
  `addNode(EditNode newNode, EditNode parentNode, Integer index, String parentProperty)`
  See `addNode()`
  `EditNode`
  `addNode(EditNode newNode, EditNode parentNode, Integer index, String parentProperty, Boolean skipParentComponentAdd)`
  See `addNode()`
  `EditNode`
  `addNode(EditNode newNode, EditNode parentNode, Integer index, String parentProperty, Boolean skipParentComponentAdd, Boolean forceSingularFieldReplace)`
  Add a new `EditNode` to the EditContext, under the specified parent.
  `void`
  `addPaletteNodesFromJS(String jsCode)`
  Add `PaletteNodes` from a JavaScript source representation.
  `void`
  `addPaletteNodesFromJS(String jsCode, EditNode parentNode)`
  See `addPaletteNodesFromJS()`
  `void`
  `addPaletteNodesFromJS(String jsCode, EditNode parentNode, String[] globals)`
  Add `PaletteNodes` from a JavaScript source representation.
  `void`
  `addPaletteNodesFromJSON(String jsonString)`
  Recreate `EditNodes` from a JSON representation of `PaletteNodes` (possibly created by calling `serializeAllEditNodesAsJSON()` or `serializeEditNodesAsJSON()`.
  `void`
  `addPaletteNodesFromJSON(String jsonString, EditNode parentNode)`
  See `addPaletteNodesFromJSON()`
  `void`
  `addPaletteNodesFromJSON(String jsonString, EditNode parentNode, String[] globals)`
  See `addPaletteNodesFromJSON()`
  `void`
  `addPaletteNodesFromJSON(String jsonString, EditNode parentNode, String[] globals, Function callback)`
  Recreate `EditNodes` from a JSON representation of `PaletteNodes` (possibly created by calling `serializeAllEditNodesAsJSON()` or `serializeEditNodesAsJSON()`.
  `void`
  `addPaletteNodesFromXML(String xmlString)`
  Recreate `EditNodes` from an XML representation of `PaletteNodes` (possibly created by calling `serializeAllEditNodes()` or `serializeEditNodes()`.
  `void`
  `addPaletteNodesFromXML(String xmlString, EditNode parentNode)`
  See `addPaletteNodesFromXML()`
  `void`
  `addPaletteNodesFromXML(String xmlString, EditNode parentNode, String[] globals)`
  See `addPaletteNodesFromXML()`
  `void`
  `addPaletteNodesFromXML(String xmlString, EditNode parentNode, String[] globals, Function callback)`
  Recreate `EditNodes` from an XML representation of `PaletteNodes` (possibly created by calling `serializeAllEditNodes()` or `serializeEditNodes()`.
  `static void`
  `changeAutoChildDefaults(String autoChildName, Canvas defaults)`
  Changes the defaults for Canvas AutoChildren named `autoChildName`.
  `static void`
  `changeAutoChildDefaults(String autoChildName, FormItem defaults)`
  Changes the defaults for FormItem AutoChildren named `autoChildName`.
  `void`
  `copyEditNodes(EditNode editNode)`
  Copies the passed editNode or editNodes to an internal "clipboard" space, for later application via `pasteEditNodes()`.
  `void`
  `copyEditNodes(EditNode... editNode)`
  Copies the passed editNode or editNodes to an internal "clipboard" space, for later application via `pasteEditNodes()`.
  `protected JavaScriptObject`
  `create()`
  `void`
  `destroyAll()`
  Removes all `EditNodes` from the EditContext, and calls `destroy()` on the `liveObjects`.
  `void`
  `enableEditing(EditNode editNode)`
  Enable edit mode for an `EditNode`.
  `Boolean`
  `getAllowNestedDrops()`
  Controls whether components can be dropped into other components which support child components.
  `Boolean`
  `getAutoEditNewNodes()`
  New nodes added to the editContext are automatically placed into edit mode if the new node's parent is in edit mode.
  `Boolean`
  `getCanDragGroup()`
  Should the group selection box shown when `canGroupSelect` is true allow dragging the group as a whole?
  `Boolean`
  `getCanGroupSelect()`
  Should a group selection outline covering the outermost bounding boxes of all selected components be shown in this container?
  `boolean`
  `getCanSaveSearches()`
  Option to save searches is disabled for editTree
  `boolean`
  `getCanShowFilterEditor()`
  Option to show filter editor is disabled for editTree
  `Palette`
  `getDefaultPalette()`
  `Palette` to use when an `EditNode` is being created directly by this EditContext, instead of being created due to a user interaction with a palette (eg dragging from a `TreePalette`, or clicking on `MenuPalette`).
  `EditContext`
  `getEditContext()`
  The `EditContext` managed by this EditTree.
  `Tree`
  `getEditNodeTree()`
  Gets the tree of editNodes being edited by this editContext.
  `Palette[]`
  `getExtraPalettes()`
  Additional `Palettes` to consult for metadata when deserializing `Edit Nodes`.
  `Boolean`
  `getHideGroupBorderOnDrag()`
  Should the group selection box shown when `canGroupSelect` is true be hidden during drag?
  `LogicalStructureObject`
  `getLogicalStructure()`
  Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
  `void`
  `getNodeProperty(EditNode editNode, String name)`
  Returns the specified property from the editNode's serializable "defaults".
  `static EditTree`
  `getOrCreateRef(JavaScriptObject jsObj)`
  `void`
  `getPaletteNodesFromJS(String jsCode, PaletteNodeCallback callback)`
  Obtain `PaletteNodes` from a JavaScript source representation.
  `void`
  `getPaletteNodesFromJS(String jsCode, PaletteNodeCallback callback, String[] globals)`
  Obtain `PaletteNodes` from a JavaScript source representation.
  `void`
  `getPaletteNodesFromXML(String xmlString, PaletteNodeCallback callback)`
  Obtain `PaletteNodes` from an XML representation, but do not add them to the EditContext.
  `Boolean`
  `getPersistCoordinates()`
  When enabled, changes to a `liveObject`'s position and size will be persisted to their `EditNodes` by default.
  `Record`
  `getRootComponent()`
  Root of data to edit.
  `EditNode`
  `getRootEditNode()`
  Returns the root `EditNode` of the EditContext typically created from `rootComponent`.
  `String`
  `getSelectedBorder()`
  Set the CSS border to be applied to the selection outline of the selected components.
  `String`
  `getSelectedLabelBackgroundColor()`
  The background color for the selection outline label.
  `Boolean`
  `getShowSelectedLabel()`
  Should the selection outline show a label for selected components? A component may also be highlighted with the selection outline and label to indicate the target of a drop.
  `Boolean`
  `getUseCopyPasteShortcuts()`
  If set, auto-enables `EditProxy.useCopyPasteShortcuts` on the `EditProxy` for the `root editNode`.
  `boolean`
  `isNodeEditingOn(EditNode editNode)`
  Returns true if `editNode` is in edit mode.
  `EditNode`
  `makeEditNode(PaletteNode paletteNode)`
  Creates and returns an EditNode using the `defaultPalette`.
  `PaletteNode`
  `makePaletteNode(EditNode editNode)`
  Creates a `PaletteNode` from an `EditNode` in this context's `editNodeTree`.
  `Tree`
  `makePaletteNodeTree(EditNode editNode, Boolean removeAutoIDs)`
  Creates a `Tree` of `PaletteNodes` from an `EditNode` in this context's `editNodeTree`, by using `makePaletteNode()` on the passed `EditNode` and its descendents within the `editNodeTree`.
  `void`
  `pasteEditNodes()`
  "Pastes" `editNodes` previously captured via `copyEditNodes()`.
  `void`
  `pasteEditNodes(EditNode targetEditNode)`
  "Pastes" `editNodes` previously captured via `copyEditNodes()`.
  `void`
  `removeAll()`
  Removes all `EditNodes` from the EditContext, but does not destroy the `liveObjects`.
  `void`
  `removeNode(EditNode editNode)`
  Removes `EditNode` from the EditContext.
  `void`
  `removeNodeProperties(EditNode editNode, String[] properties)`
  Removes the specified properties from an editNode's serializable "defaults".
  `void`
  `reorderNode(EditNode parentNode, Integer index, Integer moveToIndex)`
  Moves an `EditNode` from one child index to another in the EditContext under the specified parent.
  `String`
  `serializeAllEditNodes()`
  Serialize the tree of `EditNodes` to an XML representation of `PaletteNodes`.
  `String`
  `serializeAllEditNodes(SerializationSettings settings)`
  Serialize the tree of `EditNodes` to an XML representation of `PaletteNodes`.
  `String`
  `serializeAllEditNodesAsJSON()`
  Encode the tree of `EditNodes` to a JSON representation of `PaletteNodes`.
  `String`
  `serializeAllEditNodesAsJSON(SerializationSettings settings)`
  Encode the tree of `EditNodes` to a JSON representation of `PaletteNodes`.
  `String`
  `serializeEditNodes(EditNode[] nodes)`
  Serialize the provided `EditNodes` to an XML representation of `PaletteNodes`.
  `String`
  `serializeEditNodes(EditNode[] nodes, SerializationSettings settings)`
  Serialize the provided `EditNodes` to an XML representation of `PaletteNodes`.
  `String`
  `serializeEditNodesAsJSON(EditNode[] nodes)`
  Serialize the provided `EditNodes` to a JSON representation of `PaletteNodes`.
  `String`
  `serializeEditNodesAsJSON(EditNode[] nodes, SerializationSettings settings)`
  Serialize the provided `EditNodes` to a JSON representation of `PaletteNodes`.
  `EditTree`
  `setAllowNestedDrops(Boolean allowNestedDrops)`
  Controls whether components can be dropped into other components which support child components.
  `EditTree`
  `setAutoEditNewNodes(Boolean autoEditNewNodes)`
  New nodes added to the editContext are automatically placed into edit mode if the new node's parent is in edit mode.
  `EditTree`
  `setCanDragGroup(Boolean canDragGroup)`
  Should the group selection box shown when `canGroupSelect` is true allow dragging the group as a whole?
  `EditTree`
  `setCanGroupSelect(Boolean canGroupSelect)`
  Should a group selection outline covering the outermost bounding boxes of all selected components be shown in this container?
  `EditTree`
  `setCanSaveSearches(boolean canSaveSearches)`
  Option to save searches is disabled for editTree
  `EditTree`
  `setCanShowFilterEditor(boolean canShowFilterEditor)`
  Option to show filter editor is disabled for editTree
  `EditTree`
  `setDefaultPalette(Palette defaultPalette)`
  `Palette` to use when an `EditNode` is being created directly by this EditContext, instead of being created due to a user interaction with a palette (eg dragging from a `TreePalette`, or clicking on `MenuPalette`).
  `static void`
  `setDefaultProperties(EditTree editTreeProperties)`
  Class level method to set the default properties of this class.
  `EditTree`
  `setEditContext(EditContext editContext)`
  The `EditContext` managed by this EditTree.
  `EditTree`
  `setExtraPalettes(Palette... extraPalettes)`
  Additional `Palettes` to consult for metadata when deserializing `Edit Nodes`.
  `EditTree`
  `setHideGroupBorderOnDrag(Boolean hideGroupBorderOnDrag)`
  Should the group selection box shown when `canGroupSelect` is true be hidden during drag?
  `LogicalStructureObject`
  `setLogicalStructure(EditTreeLogicalStructure s)`
  Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
  `void`
  `setNodeProperties(EditNode editNode, Canvas properties)`
  Update an editNode's serializable "defaults" with the supplied properties.
  `void`
  `setNodeProperties(EditNode editNode, Canvas properties, Boolean skipLiveObjectUpdate)`
  Update an editNode's serializable "defaults" with the supplied properties.
  `EditTree`
  `setPersistCoordinates(Boolean persistCoordinates)`
  When enabled, changes to a `liveObject`'s position and size will be persisted to their `EditNodes` by default.
  `EditTree`
  `setRootComponent(Record rootComponent)`
  Root of data to edit.
  `EditTree`
  `setSelectedBorder(String selectedBorder)`
  Set the CSS border to be applied to the selection outline of the selected components.
  `EditTree`
  `setSelectedLabelBackgroundColor(String selectedLabelBackgroundColor)`
  The background color for the selection outline label.
  `EditTree`
  `setShowSelectedLabel(Boolean showSelectedLabel)`
  Should the selection outline show a label for selected components? A component may also be highlighted with the selection outline and label to indicate the target of a drop.
  `EditTree`
  `setUseCopyPasteShortcuts(Boolean useCopyPasteShortcuts)`
  If set, auto-enables `EditProxy.useCopyPasteShortcuts` on the `EditProxy` for the `root editNode`.

  ### Methods inherited from class com.smartgwt.client.widgets.tree.TreeGrid

  `addDataArrivedHandler, addDataChangedHandler, addFolderClickHandler, addFolderClosedHandler, addFolderContextClickHandler, addFolderDropHandler, addFolderOpenedHandler, addLeafClickHandler, addLeafContextClickHandler, addNodeClickHandler, addNodeContextClickHandler, addRecordDropHandler, canEditCell, closeFolder, exportClientData, exportClientData, exportClientData, fetchData, fetchData, fetchData, fetchData, filterData, filterData, filterData, getAlwaysShowOpener, getAnimateFolderEffect, getAnimateFolderMaxRows, getAnimateFolders, getAnimateFolderSpeed, getAnimateFolderTime, getAutoAssignTreeField, getAutoFetchTextMatchStyle, getAutoOpenTree, getAutoPreserveOpenState, getCanAcceptDroppedRecords, getCanDragRecordsOut, getCanDropOnLeaves, getCanDropSiblingAfterLastNode, getCanReorderRecords, getCanReparentNodes, getCanSelectAll, getCantDragIntoChildMessage, getCantDragIntoSelfMessage, getCantDragMultipleNodeOccurencesMessage, getCascadeSelection, getCellAlign, getChildCannotBeItsOwnAncestorMessage, getClosedIconSuffix, getConnectorIconWidth, getConnectorImage, getConnectorImageAsSCStatefulImgConfig, getCreateDefaultTreeField, getCustomIconDropProperty, getCustomIconOpenProperty, getCustomIconProperty, getCustomIconSelectedProperty, getData, getDataArity, getDataFetchMode, getDataProperties, getDisplayNodeType, getDraggedNodeLocators, getDragRecategorize, getDropEndSpace, getDropFolder, getDropIconSuffix, getEventRow, getEventRow, getExtraIcon, getExtraIconGap, getFolderIcon, getFolderIconPadding, getGroupByField, getGroupByFieldAsStringArray, getIcon, getIconBaseStyle, getIconPadding, getIconPaddingProperty, getIconSize, getIndentRecordComponents, getIndentSize, getKeepParentsOnFilter, getLeaveSelectionCheckboxGap, getLoadDataOnDemand, getLoadingIcon, getManyItemsImage, getNodeIcon, getNodeTitle, getOfflineNodeMessage, getOpenerIconHeight, getOpenerIconSize, getOpenerIconWidth, getOpenerImage, getOpenerImageAsSCStatefulImgConfig, getOpenIcon, getOpenIconPadding, getOpenIconSuffix, getOpenState, getParentAlreadyContainsChildMessage, getRecord, getRecordDropAppearance, getRecords, getSaveOpenStateInViewState, getSelectedIconSuffix, getSelectedPaths, getSelectedRecord, getSelectionProperty, getSeparateFolders, getServerFilterFields, getShowConnectors, getShowCustomIconDrop, getShowCustomIconOpen, getShowCustomIconSelected, getShowDisabledSelectionCheckbox, getShowDropEndSpace, getShowDropIcons, getShowFolderIcons, getShowFullConnectors, getShowLoadingIcons, getShowNodeIcons, getShowOpener, getShowOpenIcons, getShowPartialSelection, getShowRoot, getShowSelectedIcons, getShowSelectedOpener, getSortFoldersBeforeLeaves, getTree, getTreeFieldMinWidth, getTreeFieldTitle, getTreeRootValue, getUseAllDataSourceFields, groupBy, isExportingClientData, isOverExtraIcon, isOverOpenArea, loadAllRecords, loadAllRecords, loadAllRecords, onInit, openFolder, openFolder, recordDoubleClick, setAlwaysShowOpener, setAnimateFolderEffect, setAnimateFolderMaxRows, setAnimateFolders, setAnimateFolderSpeed, setAnimateFolderTime, setAutoAssignTreeField, setAutoFetchTextMatchStyle, setAutoOpenTree, setAutoPreserveOpenState, setCanAcceptDroppedRecords, setCanDragRecordsOut, setCanDropOnLeaves, setCanDropSiblingAfterLastNode, setCanReorderRecords, setCanReparentNodes, setCanSelectAll, setCantDragIntoChildMessage, setCantDragIntoSelfMessage, setCantDragMultipleNodeOccurencesMessage, setCascadeSelection, setCellValueHoverFormatter, setChildCannotBeItsOwnAncestorMessage, setClosedIconSuffix, setConnectorIconWidth, setConnectorImage, setConnectorImage, setCreateDefaultTreeField, setCustomIconDropProperty, setCustomIconOpenProperty, setCustomIconProperty, setCustomIconSelectedProperty, setCustomNodeIcon, setData, setDataArity, setDataFetchMode, setDataProperties, setDefaultProperties, setDisplayNodeType, setDragRecategorize, setDropEndSpace, setDropIconSuffix, setExtraIconGap, setFields, setFolderIcon, setFolderIconPadding, setGroupByField, setGroupByField, setIconBaseStyle, setIconPadding, setIconPaddingProperty, setIconSize, setIndentRecordComponents, setIndentSize, setInitialData, setKeepParentsOnFilter, setLeaveSelectionCheckboxGap, setLoadDataOnDemand, setLoadingIcon, setLogicalStructure, setManyItemsImage, setNodeIcon, setOfflineNodeMessage, setOpenerIconHeight, setOpenerIconSize, setOpenerIconWidth, setOpenerImage, setOpenerImage, setOpenIconPadding, setOpenIconSuffix, setOpenState, setParentAlreadyContainsChildMessage, setRecordDropAppearance, setSaveOpenStateInViewState, setSelectedIconSuffix, setSelectedPaths, setSelectionProperty, setSeparateFolders, setServerFilterFields, setShowConnectors, setShowCustomIconDrop, setShowCustomIconOpen, setShowCustomIconSelected, setShowDisabledSelectionCheckbox, setShowDropEndSpace, setShowDropIcons, setShowFolderIcons, setShowFullConnectors, setShowLoadingIcons, setShowNodeIcons, setShowOpener, setShowOpenIcons, setShowPartialSelection, setShowRoot, setShowSelectedIcons, setShowSelectedOpener, setSortFoldersBeforeLeaves, setTreeFieldMinWidth, setTreeFieldTitle, setTreeRootValue, setTreeRootValue, setUseAllDataSourceFields, startEditingNew, toggleFolder, toggleFolder, toggleFolder, toggleFolder, transferNodes, willAcceptDrop`

  ### Methods inherited from class com.smartgwt.client.widgets.grid.ListGrid

  `addBodyKeyPressHandler, addCellClickHandler, addCellContextClickHandler, addCellDoubleClickHandler, addCellErrorIconHoverHandler, addCellErrorIconOutHandler, addCellErrorIconOverHandler, addCellHoverHandler, addCellMouseDownHandler, addCellMouseUpHandler, addCellOutHandler, addCellOverHandler, addCellSavedHandler, addCellSelectionChangedHandler, addCellValueHoverHandler, addCriteriaChangedHandler, addData, addData, addData, addDataArrivedHandler, addDataChangedHandler, addDragCompleteHandler, addDrawAreaChangedHandler, addDropCompleteHandler, addEditCompleteHandler, addEditFailedHandler, addEditorEnterHandler, addEditorExitHandler, addEmbeddedComponent, addEmbeddedComponent, addEmbeddedComponent, addEmbeddedComponent, addFetchDataHandler, addFieldStateChangedHandler, addFilterEditorSubmitHandler, addFormulaField, addFormulaUpdatedHandler, addGroupByCompleteHandler, addGroupByHandler, addGroupStateChangedHandler, addGroupTreeChangedHandler, addHeaderClickHandler, addHeaderDoubleClickHandler, addHeaderHoverHandler, addHilitesChangedHandler, addRecordClickHandler, addRecordCollapseHandler, addRecordDoubleClickHandler, addRecordExpandHandler, addRegroupHandler, addRemoveRecordClickHandler, addRowContextClickHandler, addRowEditorEnterHandler, addRowEditorExitHandler, addRowHoverHandler, addRowMouseDownHandler, addRowMouseUpHandler, addRowOutHandler, addRowOverHandler, addSelectionChangedHandler, addSelectionUpdatedHandler, addSetSortHandler, addSort, addSortChangedHandler, addSorterClickHandler, addSorterContextClickHandler, addSummaryField, addViewStateChangedHandler, anySelected, applyCellData, applyRecordData, applySortToData, askForSort, autoFitField, autoFitFields, autoFitFields, cancelEditing, canExpandRecord, canSelectCell, canSelectRecord, cellHasChanges, cellHasErrors, cellHasErrors, cellValueHoverHTML, cellValueIsClipped, chartData, chartData, chartData, chartData, chartData, clearAllCriteria, clearCriteria, clearCriteria, clearCriteria, clearEditValue, clearFieldError, clearFieldError, clearFieldSearchOperator, clearFilterWindowCriteria, clearRowErrors, clearSavedViewState, clearSort, closeGroup, closeRecord, collapseRecord, collapseRecords, configureGrouping, createRecordComponent, dataChangedComplete, dataChangedComplete, deselectAllRecords, deselectRange, deselectRecord, deselectRecord, deselectRecords, deselectRecords, disableHilite, disableHiliting, discardAllEdits, discardAllEdits, discardAllEdits, discardEdits, discardEdits, displayHeaderContextMenu, displaySort, drop, editExistingRecord, editExistingRecord, editFields, editHilites, enableHilite, enableHilite, enableHiliting, enableHiliting, endEditing, expandRecord, expandRecords, exportData, exportData, exportData, fetchRelatedData, fetchRelatedData, fetchRelatedData, fetchRelatedData, fetchRelatedData, fetchRowCount, fetchRowCount, fetchRowCount, fieldIsEditable, fieldIsEditable, fieldIsEditable, fieldIsVisible, filterByEditor, filterData, filterViaAI, filterViaAI, find, findAll, findIndex, findNextEditCell, findNextIndex, findNextIndex, focusInCell, focusInFilterEditor, focusInFilterEditor, focusInRow, freezeField, freezeField, freezeField, freezeField, freezeFields, freezeFields, getAddDropValues, getAddFormulaFieldText, getAddOperation, getAddSummaryFieldText, getAdvancedFieldPickerThreshold, getAdvancedFilteringText, getAiFilterWindow, getAiFilterWindowHint, getAiFilterWindowInstructions, getAiFilterWindowTitle, getAiHiliteWindow, getAiHoverContentsPrefix, getAiHoverRetryDelay, getAiSortProgressDialog, getAllEditRows, getAllFields, getAllowFilterExpressions, getAllowFilterOperators, getAllowFilterWindow, getAllowRowSpanning, getAlternateBodyStyleName, getAlternateFieldFrequency, getAlternateFieldStyles, getAlternateFieldSuffix, getAlternateRecordFrequency, getAlternateRecordStyles, getAlternateRecordSuffix, getAlwaysShowEditors, getAlwaysShowOperatorIcon, getAnimateRemoveRecord, getAnimateRemoveSpeed, getAnimateRemoveTime, getAnimateRollOver, getAnimateRollUnder, getAnimateSelection, getAnimateSelectionUnder, getApplyFormulaAfterSummary, getApplyRowCountToLength, getApplyRowNumberStyle, getApproximateRowCountFormat, getAriaRole, getAriaState, getAriaStateDefaults, getArrowKeyAction, getArrowKeyEditAction, getAsyncErrorCellValue, getAsynchGroupingPrompt, getAsyncMissingCellValue, getAutoComplete, getAutoConfirmSaveEdits, getAutoFetchAsFilter, getAutoFetchData, getAutoFetchDisplayMap, getAutoFetchRowCount, getAutoFitAllText, getAutoFitClipFields, getAutoFitData, getAutoFitDateFields, getAutoFitExpandField, getAutoFitExpandLengthThreshold, getAutoFitExtraRecords, getAutoFitFieldsFillViewport, getAutoFitFieldText, getAutoFitFieldWidths, getAutoFitHeaderHeights, getAutoFitIconFields, getAutoFitMaxColumns, getAutoFitMaxHeight, getAutoFitMaxRecords, getAutoFitMaxWidth, getAutoFitMaxWidthAsString, getAutoFitTimeFields, getAutoFitWidthApproach, getAutoHideCanvasGrid, getAutoPersistViewState, getAutoSaveEdits, getAutoSizeHeaderSpans, getBackgroundComponent, getBadFormulaResultValue, getBaseStyle, getBaseStyle, getBlockingRowCountFetch, getBody, getBodyBackgroundColor, getBodyOverflow, getBodyScrollLeft, getBodyScrollTop, getBodyStyleName, getBooleanBaseStyle, getBooleanFalseImage, getBooleanImageHeight, getBooleanImageWidth, getBooleanPartialImage, getBooleanTrueImage, getBriefRowRangeDisplayValue, getCanAddAISortFields, getCanAddAISummaryFields, getCanAddFormulaFields, getCanAddSummaryFields, getCanAutoFitFields, getCancelEditingConfirmationMessage, getCanCollapseGroup, getCanConfigureViaAI, getCanDragSelect, getCanDragSelectText, getCanDropInEmptyArea, getCanEdit, getCanEditHilites, getCanEditTitles, getCanExpandMultipleRecords, getCanExpandRecordProperty, getCanExpandRecords, getCanFocusInEmptyGrid, getCanFreezeFields, getCanGroupBy, getCanHiliteViaAI, getCanHover, getCanMultiGroup, getCanMultiSort, getCanPickFields, getCanPickOmittedFields, getCanRemoveRecords, getCanReorderFields, getCanRequestRowCount, getCanResizeFields, getCanSelectCells, getCanSelectGroups, getCanSelectOnRecordClick, getCanSelectSummaryRows, getCanSort, getCanTabToHeader, getCanTabToSorter, getCanvasGridConstructor, getCellAriaState, getCellContextMenu, getCellContextMenuItems, getCellCSSText, getCellElement, getCellErrors, getCellHeight, getCellHoverComponent, getCellPadding, getCellPageRect, getCellRole, getCellRowSpan, getCellSelection, getCellStartRow, getCellStyle, getCellValue, getCentralStyling, getChartConstructor, getChartType, getCheckboxFieldFalseImage, getCheckboxFieldImageHeight, getCheckboxFieldImageWidth, getCheckboxFieldPartialImage, getCheckboxFieldTrueImage, getChildExpansionMode, getClearAllSortingText, getClearCriteriaOnFilterEditorHide, getClearFilterText, getClearFilterViaAIText, getClearSortFieldText, getClipHeaderTitles, getCollapseGroupOnRowClick, getColumnLeft, getColumnPageLeft, getColumnWidth, getConfigureGroupingText, getConfigureSortText, getConfigureViaAIText, getConfirmCancelEditing, getConfirmDiscardEdits, getConfirmDiscardEditsMessage, getCriteria, getCriteriaIndicatorColor, getCriteriaIndicatorHeaderColor, getCurrentExpansionComponent, getCurrentExpansionComponent, getCurrentFieldWidths, getDataAsJSList, getDataAsRecordList, getDataFetchDelay, getDataPageSize, getDataSource, getDateFormatter, getDatetimeFormatter, getDeepCloneOnEdit, getDefaultDateFieldWidth, getDefaultDateTimeFieldWidth, getDefaultEditableDateFieldWidth, getDefaultEditableDateTimeFieldWidth, getDefaultFields, getDefaultFilterOperator, getDefaultFilterOperatorSuffix, getDefaultFormattedFieldValue, getDefaultFormattedFieldValue, getDefaultFormattedFieldValue, getDefaultFormattedValue, getDefaultTimeFieldWidth, getDeferRemoval, getDeselectOnPartialCheckboxClick, getDetailDS, getDetailField, getDisabledGroupByPrompt, getDiscardDataOnSetFetchOperation, getDiscardEditsOnHideField, getDiscardEditsSaveButtonTitle, getDisplayValue, getDisplayValue, getDisplayValue, getDisplayValue, getDisplayValue, getDivGrid, getDragData, getDragDataAction, getDragHandleField, getDragHandleFieldTitle, getDragHandleIcon, getDragHandleIconSize, getDragScrollRedrawDelay, getDragTrackerMode, getDragTrackerStyle, getDrawAheadRatio, getDrawAllMaxCells, getDrawArea, getDrawnRowHeight, getDrawnRows, getDropValues, getDuplicateDragMessage, getEditByCell, getEditCol, getEditedCell, getEditedCell, getEditedCell, getEditedCell, getEditedRecord, getEditEvent, getEditFailedBaseStyle, getEditFailedCSSText, getEditFormItem, getEditFormItem, getEditFormulaFieldText, getEditOnF2Keypress, getEditOnFocus, getEditPendingBaseStyle, getEditPendingCSSText, getEditPendingMarkerStyle, getEditProxyConstructor, getEditRow, getEditSelectionType, getEditSummaryFieldText, getEditValue, getEditValue, getEditValueAsBoolean, getEditValueAsDate, getEditValueAsFloat, getEditValueAsInt, getEditValueAsRecord, getEditValueAsRecordArray, getEditValueAsString, getEditValues, getEditValues, getEmbeddedComponentIndent, getEmbeddedComponentMargin, getEmptyAIHoverContents, getEmptyCellValue, getEmptyMessage, getEmptyMessageStyle, getEmptyRowRangeDisplayValue, getEnforceVClipping, getEnterKeyEditAction, getEnumCriteriaAsInitialValues, getErrorIconHeight, getErrorIconSrc, getErrorIconWidth, getEscapeKeyEditAction, getEventColumn, getEventColumn, getExactRowCountFormat, getExpandedRecords, getExpansionCanEdit, getExpansionComponent, getExpansionComponentPoolingMode, getExpansionDetailField, getExpansionDetailRelated, getExpansionDetails, getExpansionEditor, getExpansionEditorCollapseOnSave, getExpansionEditorSaveButton, getExpansionEditorSaveButtonTitle, getExpansionEditorSaveDialogPrompt, getExpansionEditorShowSaveDialog, getExpansionField, getExpansionFieldFalseImage, getExpansionFieldImageHeight, getExpansionFieldImageShowRTL, getExpansionFieldImageShowSelected, getExpansionFieldImageStyle, getExpansionFieldImageWidth, getExpansionFieldTrueImage, getExpansionIndent, getExpansionLayout, getExpansionMode, getExpansionRelated, getExpansionScreen, getExplicitFetchDelay, getExportAll, getExportAlternateRowBGColor, getExportBGColor, getExportColumnBGColor, getExportColumnWidthPadding, getExportDefaultBGColor, getExportFieldAlignments, getExportFields, getExportFieldWidths, getExportHeaderHeights, getExportHiddenFieldWidth, getExportIncludeSummaries, getExportRawNumbers, getExportRawValues, getExportRowBGColor, getExportTextColor, getExportWidthScale, getExportWrapCells, getExportWrapHeaderTitles, getFetchDelay, getFetchFields, getFetchFieldsAsString, getFetchOperation, getFetchRequestProperties, getField, getField, getFieldAlignments, getFieldByName, getFieldContentWidth, getFieldCount, getFieldCriteriaText, getFieldName, getFieldNum, getFieldNum, getFieldPickerFieldProperties, getFieldPickerShowSampleValues, getFieldPickerWindow, getFields, getFieldsAsJavaScriptObjects, getFieldSearchOperator, getFieldState, getFieldTitle, getFieldTitle, getFieldVisibilitySubmenuTitle, getFieldWidth, getFieldWidth, getFilterButtonPrompt, getFilterButtonProperties, getFilterByCell, getFilterEditor, getFilterEditorCriteria, getFilterEditorCriteria, getFilterEditorCriteriaAsAdvancedCriteria, getFilterEditorCriterion, getFilterEditorHeight, getFilterEditorProperties, getFilterLocalData, getFilterOnKeypress, getFilterUsingText, getFilterViaAIMode, getFilterViaAIPanelInstructions, getFilterViaAIText, getFilterWindow, getFilterWindowCriteria, getFilterWindowCriteriaIndicator, getFilterWindowFilter, getFilterWindowInstructions, getFilterWindowTitle, getFirstCellStyle, getFixedFieldWidths, getFixedRecordHeights, getFocusRow, getFormattedRowCount, getFormattedRowRange, getFormattedValue, getFormattedValue, getFormulaBuilderSpanTitleSeparator, getFormulaFieldValue, getFreezeFieldText, getFrozenBaseStyle, getFrozenBodyStyleName, getFrozenFieldsMaxWidth, getFrozenFieldsMaxWidthAsInt, getFrozenHeaderBaseStyle, getFrozenHeaderTitleStyle, getFrozenRollOverCanvas, getFrozenRollUnderCanvas, getFullRowRangeDisplayValue, getGenerateClickOnEnter, getGenerateClickOnSpace, getGenerateDoubleClickOnEnter, getGenerateDoubleClickOnSpace, getGridAdditionalCriteriaText, getGridComponents, getGridRenderer, getGridSummary, getGridSummaryData, getGridSummaryRecordProperty, getGroupByAsyncThreshold, getGroupByFields, getGroupByFieldSummaries, getGroupByMaxRecords, getGroupByMaxRecordsExceededMessage, getGroupByText, getGroupedRecordIndex, getGroupIcon, getGroupIconSize, getGroupIconStyle, getGroupIndentSize, getGroupIndexInfo, getGroupLeadingIndent, getGroupMembers, getGroupNodeBaseStyle, getGroupNodeStyle, getGroupSortDirection, getGroupState, getGroupSummaryData, getGroupSummaryData, getGroupSummaryData, getGroupSummaryData, getGroupSummaryRecordProperty, getGroupSummaryStyle, getGroupTitleColumnProperties, getGroupTitleField, getGroupTree, getGroupTreeSelection, getGroupTreeSelection, getGroupTreeSelection, getHeader, getHeaderAriaRole, getHeaderAutoFitEvent, getHeaderBackgroundColor, getHeaderBarStyle, getHeaderBaseStyle, getHeaderButtonAriaRole, getHeaderButtonAriaState, getHeaderButtonProperties, getHeaderContextMenu, getHeaderContextMenuItems, getHeaderHeight, getHeaderHoverAlign, getHeaderHoverHeight, getHeaderHoverOpacity, getHeaderHoverStyle, getHeaderHoverVAlign, getHeaderHoverWidth, getHeaderHoverWrap, getHeaderMenuButton, getHeaderMenuButtonHeight, getHeaderMenuButtonHeightAsString, getHeaderMenuButtonIcon, getHeaderMenuButtonIconHeight, getHeaderMenuButtonIconWidth, getHeaderMenuButtonSnapOffsetLeft, getHeaderMenuButtonWidth, getHeaderRadius, getHeaderShadowColor, getHeaderShadowHOffset, getHeaderShadowSoftness, getHeaderShadowVOffset, getHeaderSpan, getHeaderSpanContextMenuItems, getHeaderSpanHeight, getHeaderTitleStyle, getHeaderTitleVAlign, getHeightForRows, getHeightForRows, getHideEmptySummaryRow, getHideFilterEditorTitle, getHiliteCanReplaceValue, getHiliteEditorSpanTitleSeparator, getHiliteHTMLAfterFormat, getHiliteIconHeight, getHiliteIconLeftPadding, getHiliteIconPosition, getHiliteIconRightPadding, getHiliteIcons, getHiliteIconSize, getHiliteIconWidth, getHiliteProperty, getHiliteReplaceValueFieldTitle, getHiliteRowOnFocus, getHilites, getHiliteState, getHiliteViaAIMode, getHiliteViaAIText, getHoverMode, getHoverScreen, getHoverStyle, getIconCursor, getImageSize, getImplicitCriteria, getIncludeHilitesInSummaryFields, getIncludeInSummaryProperty, getInitialCriteria, getInitialSort, getInlineEditItemGap, getInstantScrollTrackRedraw, getInvalidSummaryValue, getIsGrouped, getIsSeparatorProperty, getLastCellStyle, getLeaveScrollbarGap, getLinkTextProperty, getLinkTextStyleName, getListEndEditAction, getLoadingDataMessage, getLoadingDataMessageStyle, getLoadingMessage, getLoadingRowCountDisplayIcoHeight, getLoadingRowCountDisplayIcon, getLoadingRowCountDisplayIconWidth, getLocateColumnsBy, getLocateRowsBy, getLongTextEditorThreshold, getLongTextEditorType, getMaxExpandedRecords, getMaxExpandedRecordsPrompt, getMaximumRowCountFormat, getMaxSummaryRowRecords, getMinFieldWidth, getMinHeight, getMinimumCellHeight, getMinimumRowCountFormat, getMissingSummaryFieldValue, getModalEditing, getMultiGroupDialogDefaults, getMultiGroupDialogProperties, getNavigateOnTab, getNeverValidate, getNewRecordRowMessage, getNewSearchText, getNormalBaseStyle, getNormalCellHeight, getNoSavedSearchesText, getNullGroupTitle, getOfflineMessageStyle, getOperatorIcon, getOriginalRecordList, getOriginalResultSet, getOriginBaseStyle, getOverflow, getPendingAsyncCellValue, getPlaceholderAIHoverContents, getPoolComponentsPerColumn, getPreRender, getPreRenderDelay, getPreRenderFormatValues, getPreRenderImageMode, getPreRenderPlaceholderColor, getPreRenderStructureDelay, getPreRenderTransitionDuration, getPreRenderTransitionFrame, getPreRenderTransitionFrameDefaults, getPreserveFocusStylingOnMouseOut, getPreserveWhitespace, getPreventDuplicates, getPrintAutoFit, getPrintBaseStyle, getPrintBooleanBaseStyle, getPrintBooleanFalseImage, getPrintBooleanPartialImage, getPrintBooleanTrueImage, getPrintCheckboxFieldFalseImage, getPrintCheckboxFieldPartialImage, getPrintCheckboxFieldTrueImage, getPrintHeaderStyle, getPrintMaxRows, getPrintWrapCells, getProgressiveLoading, getQuickDrawAheadRatio, getRangeRowCountFormat, getRecordBaseStyleProperty, getRecordCanRemoveProperty, getRecordCanSelectProperty, getRecordCellRoleProperty, getRecordComponent, getRecordComponent, getRecordComponentHeight, getRecordComponentPoolingMode, getRecordComponentPosition, getRecordDetailDSProperty, getRecordDropPosition, getRecordEditProperty, getRecordEnabledProperty, getRecordIndex, getRecordIndex, getRecordList, getRecordRadius, getRecordRadiusTargets, getRecordRowAriaStateProperty, getRecordRowRoleProperty, getRecordScreen, getRecordShowRollOverProperty, getRecordSummaryAttributePrefix, getRecordSummaryBaseStyle, getRelatedDataSource, getRemovedCSSText, getRemoveFieldDefaults, getRemoveFieldProperties, getRemoveFieldTitle, getRemoveIcon, getRemoveIconSize, getRemoveIconStyle, getRemoveOperation, getReselectOnUpdate, getReselectOnUpdateNotifications, getResizeFieldsInRealTime, getResultSet, getReverseRTLAlign, getRollOverCanvas, getRollUnderCanvas, getRotatedHeaderMenuButtonHeight, getRotatedHeaderMenuButtonHeightAsString, getRotatedHeaderMenuButtonWidth, getRotateHeaderTitles, getRowAriaState, getRowCount, getRowCountDisplayPrecision, getRowCountRange, getRowCountStatus, getRowEndEditAction, getRowErrors, getRowHeight, getRowLocatorField, getRowLocatorFieldAsStringArray, getRowNum, getRowNumberField, getRowNumberStart, getRowNumberStyle, getRowPageTop, getRowRangeDisplay, getRowRangeDisplayStyle, getRowRangeDisplayValue, getRowRangeFormat, getRowRole, getRowSpan, getRowSpanEditMode, getRowSpanSelectionMode, getRowTop, getSaveByCell, getSaveCriteriaInViewState, getSaveDefaultSearch, getSavedSearchAdminRole, getSavedSearchAdminSeparator, getSavedSearchDS, getSavedSearchId, getSavedSearchStoredState, getSavedSearchText, getSavedViewState, getSaveLocally, getSaveRequestProperties, getScreenReaderCellSeparator, getScreenReaderIncludeFieldTitles, getScreenReaderNavigateByCell, getScreenReaderRowSeparator, getScreenReaderWriteRowLabelledBy, getScrollRedrawDelay, getScrollToCellXPosition, getScrollToCellYPosition, getScrollWheelRedrawDelay, getSearchForm, getSearchFormAsString, getSearchFormAsValuesManager, getSelectCellTextOnClick, getSelectedCellData, getSelectedRecords, getSelectedRecords, getSelectedState, getSelectHeaderOnSort, getSelection, getSelection, getSelectionAppearance, getSelectionType, getSelectOnEdit, getSelectOnExpandRecord, getSeparatorRowStyle, getShowAllColumns, getShowAllRecords, getShowAsynchGroupingPrompt, getShowBackgroundComponents, getShowCellContextMenus, getShowClippedHeaderTitlesOnHover, getShowClippedValuesOnHover, getShowCollapsedGroupSummary, getShowComplexFields, getShowDetailFields, getShowDropLines, getShowDropOverRollOver, getShowEllipsisWhenClipped, getShowEmptyMessage, getShowErrorIcons, getShowExpansionEditorSaveButton, getShowFilterEditor, getShowFilterEditorHovers, getShowFilterEditorTitle, getShowFilterWindowCriteriaIndicator, getShowGridSummary, getShowGroupSummary, getShowGroupSummaryInHeader, getShowGroupTitleColumn, getShowGroupTitleInFrozenBody, getShowHeader, getShowHeaderContextMenu, getShowHeaderMenuButton, getShowHeaderPartialSelection, getShowHeaderSeparators, getShowHeaderShadow, getShowHeaderSpanContextMenu, getShowHeaderSpanTitlesInFormulaBuilder, getShowHeaderSpanTitlesInHiliteEditor, getShowHeaderSpanTitlesInSortEditor, getShowHiddenFields, getShowHilitesInGroupSummary, getShowHover, getShowHoverComponents, getShowHoverOnDisabledCells, getShowInitialDragHandles, getShowLastHeaderSeparators, getShowNewRecordRow, getShowPreRenderTransition, getShowRecordComponents, getShowRecordComponentsByCell, getShowRollOver, getShowRollOverCanvas, getShowRollOverInExpansion, getShowRollUnderCanvas, getShowRowNumbers, getShowSavedSearchesByDS, getShowSelectedRollOverCanvas, getShowSelectedRollUnderCanvas, getShowSelectedStyle, getShowSelectionCanvas, getShowSelectionUnderCanvas, getShowSortArrow, getShowSortNumerals, getShowTreeColumnPicker, getShrinkForFreeze, getSingleCellValueProperty, getSkinImgDir, getSkipClipDiv, getSkipLineBreaks, getSort, getSortArrowMenuButtonSpaceOffset, getSortAscendingImage, getSortAscendingImageAsImgHTMLProperties, getSortBinaryByFileName, getSortByGroupFirst, getSortDescendingImage, getSortDescendingImageAsImgHTMLProperties, getSortDirection, getSortEditorSpanTitleSeparator, getSorterButtonTitle, getSortField, getSortFieldAscendingText, getSortFieldCount, getSortFieldDescendingText, getSortNumeralHTML, getSortNumeralMenuButtonSpaceOffset, getSortNumeralStyle, getSortSpecifier, getSortState, getSpanContextMenu, getSpannedHeaderBaseStyle, getSparseFieldState, getStopOnErrors, getStyledRowEnds, getStyleName, getSummaryFieldValue, getSummaryRow, getSummaryRowCriteria, getSummaryRowDataSource, getSummaryRowFetchRequestProperties, getSummaryRowHeight, getSummaryRowStyle, getTableRowStyle, getTallBaseStyle, getTestInstance, getTitleField, getTitleFieldValue, getToggleFreezeText, getTotalRows, getTouchScrollRedrawDelay, getTrackerImage, getTrackerImageAsImgHTMLProperties, getUnfreezeFieldText, getUngroupText, getUnknownRowCountDisplayValue, getUnremoveIcon, getUpdateOperation, getUpdateSummariesDuringEditing, getUseAdvancedCriteria, getUseAdvancedFieldPicker, getUseCellRollOvers, getUseClientFiltering, getUseFlatFields, getUseInlineEditors, getUseInlineFilterEditors, getUseLegacyDefaultFormattedValue, getUseMultiSelectForFilterValueMaps, getUserCriteriaState, getUseRemoteValidators, getUseRowSpanStyling, getValidateByCell, getValidateOnChange, getValueIcon, getValueIconCursor, getValueIconHeight, getValueIconLeftPadding, getValueIconRightPadding, getValueIconSize, getValueIconWidth, getViewState, getVirtualScrolling, getVisibleRows, getWaitForSave, getWarnOnRemoval, getWarnOnRemovalMessage, getWarnOnUnmappedValueFieldChange, getWrapCells, getWrapHeaderSpanTitles, getWrapHeaderTitles, groupBy, groupSortNormalizer, hasChanges, hasChanges, hasErrors, headerHoverHTML, headerTitleClipped, hideDragHandles, hideField, hideField, hideFields, hideFields, hideFields, hideFields, hiliteViaAI, hiliteViaAI, hiliteViaAI, invalidateCache, invalidateRecordComponents, isCheckboxField, isExpanded, isExpansionField, isGrouped, isGroupNode, isPartiallySelected, isPreRendering, isRowNumberField, isSelected, isSortField, isSummaryRecord, markForRedraw, markForRedraw, markRecordRemoved, markRecordsRemoved, markRecordsRemoved, markRecordsRemoved, markSelectionRemoved, onInit_ListGrid, openGroup, openRecordDetailGrid, openRecordEditor, preloadImages, preRenderDone, preRenderHTMLReplaced, recalculateGridSummary, recalculateSummaries, recalculateSummaries, recalculateSummaries, recordClick, recordMarkedAsRemoved, redrawHeader, refreshAIField, refreshAIField, refreshCell, refreshCell, refreshCellStyle, refreshData, refreshData, refreshFields, refreshRecordComponent, refreshRecordComponent, refreshRow, regroup, removeData, removeData, removeData, removeEmbeddedComponent, removeEmbeddedComponent, removeEmbeddedComponent, removeRecordClick, removeSelectedData, removeSelectedData, removeSelectedData, removeSelectedData, reorderField, reorderFields, resizeField, resort, rowClick, rowClick, rowDoubleClick, rowDoubleClick, rowHasChanges, rowHasChanges, rowHasErrors, saveAllEdits, saveAllEdits, saveAllEdits, saveEdits, saveEdits, saveEdits, saveEdits, scrollBodyTo, scrollToCell, scrollToCell, scrollToCell, scrollToColumn, scrollToColumn, scrollToRow, scrollToRow, selectAllRecords, selectRange, selectRange, selectRecord, selectRecord, selectRecord, selectRecord, selectRecords, selectRecords, selectRecords, selectRecords, selectSingleRecord, selectSingleRecord, setAddDropValues, setAddFormulaFieldText, setAddOperation, setAddSummaryFieldText, setAdvancedFieldPickerThreshold, setAdvancedFilteringText, setAiFilterWindowHint, setAiFilterWindowInstructions, setAiFilterWindowTitle, setAiHoverContentsPrefix, setAiHoverRetryDelay, setAllowFilterExpressions, setAllowFilterOperators, setAllowFilterWindow, setAllowRowSpanning, setAlternateBodyStyleName, setAlternateFieldFrequency, setAlternateFieldStyles, setAlternateFieldSuffix, setAlternateRecordFrequency, setAlternateRecordStyles, setAlternateRecordSuffix, setAlwaysShowEditors, setAlwaysShowOperatorIcon, setAnimateRemoveRecord, setAnimateRemoveSpeed, setAnimateRemoveTime, setAnimateRollOver, setAnimateRollUnder, setAnimateSelection, setAnimateSelectionUnder, setApplyFormulaAfterSummary, setApplyRowCountToLength, setApplyRowNumberStyle, setApproximateRowCountFormat, setAriaRole, setArrowKeyAction, setArrowKeyEditAction, setAsyncErrorCellValue, setAsynchGroupingPrompt, setAsyncMissingCellValue, setAutoChildProperties, setAutoComplete, setAutoConfirmSaveEdits, setAutoFetchAsFilter, setAutoFetchData, setAutoFetchDisplayMap, setAutoFetchRowCount, setAutoFitAllText, setAutoFitClipFields, setAutoFitData, setAutoFitDateFields, setAutoFitExpandField, setAutoFitExpandLengthThreshold, setAutoFitExtraRecords, setAutoFitFieldsFillViewport, setAutoFitFieldText, setAutoFitFieldWidths, setAutoFitHeaderHeights, setAutoFitIconFields, setAutoFitMaxColumns, setAutoFitMaxHeight, setAutoFitMaxRecords, setAutoFitMaxWidth, setAutoFitMaxWidth, setAutoFitTimeFields, setAutoFitWidth, setAutoFitWidthApproach, setAutoHideCanvasGrid, setAutoPersistViewState, setAutoSaveEdits, setAutoSizeHeaderSpans, setBadFormulaResultValue, setBaseStyle, setBlockingRowCountFetch, setBodyBackgroundColor, setBodyOverflow, setBodyStyleName, setBooleanBaseStyle, setBooleanFalseImage, setBooleanImageHeight, setBooleanImageWidth, setBooleanPartialImage, setBooleanTrueImage, setBriefRowRangeDisplayValue, setCanAddAISortFields, setCanAddAISummaryFields, setCanAddFormulaFields, setCanAddSummaryFields, setCanAutoFitFields, setCancelEditingConfirmationMessage, setCanCollapseGroup, setCanConfigureViaAI, setCanDragSelect, setCanDragSelectText, setCanDropInEmptyArea, setCanEdit, setCanEditHilites, setCanEditTitles, setCanExpandMultipleRecords, setCanExpandRecordProperty, setCanExpandRecords, setCanFocusInEmptyGrid, setCanFreezeFields, setCanGroupBy, setCanHiliteViaAI, setCanHover, setCanMultiGroup, setCanMultiSort, setCanPickFields, setCanPickOmittedFields, setCanRemoveRecords, setCanReorderFields, setCanRequestRowCount, setCanResizeFields, setCanSelectCells, setCanSelectGroups, setCanSelectOnRecordClick, setCanSelectRecordCustomizer, setCanSelectSummaryRows, setCanSort, setCanTabToHeader, setCanTabToSorter, setCanvasGridConstructor, setCellContextMenuItemsCustomizer, setCellCSSTextCustomizer, setCellFormatter, setCellHeight, setCellPadding, setCellRole, setCentralStyling, setChartConstructor, setChartType, setCheckboxFieldFalseImage, setCheckboxFieldImageHeight, setCheckboxFieldImageWidth, setCheckboxFieldPartialImage, setCheckboxFieldProperties, setCheckboxFieldTrueImage, setChildExpansionMode, setClearAllSortingText, setClearCriteriaOnFilterEditorHide, setClearFilterText, setClearFilterViaAIText, setClearSortFieldText, setClipHeaderTitles, setCollapseGroupOnRowClick, setConfigureGroupingText, setConfigureSortText, setConfigureViaAIText, setConfirmCancelEditing, setConfirmDiscardEdits, setConfirmDiscardEditsMessage, setCriteria, setCriteriaIndicatorColor, setCriteriaIndicatorHeaderColor, setData, setData, setData, setDataFetchDelay, setDataPageSize, setDataProperties, setDataSource, setDataSource, setDataSource, setDateFormatter, setDateInputFormat, setDatetimeFormatter, setDeepCloneOnEdit, setDefaultDateFieldWidth, setDefaultDateTimeFieldWidth, setDefaultEditableDateFieldWidth, setDefaultEditableDateTimeFieldWidth, setDefaultFields, setDefaultFieldWidthCustomizer, setDefaultFilterOperator, setDefaultFilterOperatorSuffix, setDefaultProperties, setDefaultTimeFieldWidth, setDeferRemoval, setDeselectOnPartialCheckboxClick, setDetailDS, setDetailDS, setDetailField, setDisabledGroupByPrompt, setDiscardDataOnSetFetchOperation, setDiscardEditsOnHideField, setDiscardEditsSaveButtonTitle, setDivGrid, setDontAutoDestroyComponent, setDragDataAction, setDragDataCustomizer, setDragHandleFieldTitle, setDragHandleIcon, setDragHandleIconSize, setDragScrollRedrawDelay, setDragTrackerIconCustomizer, setDragTrackerMode, setDragTrackerStyle, setDragTrackerTitleCustomizer, setDrawAheadRatio, setDrawAllMaxCells, setDropValues, setDuplicateDragMessage, setEditByCell, setEditEvent, setEditFailedBaseStyle, setEditFailedCSSText, setEditFormulaFieldText, setEditOnF2Keypress, setEditOnFocus, setEditorCustomizer, setEditorValueMap, setEditorValueMap, setEditPendingBaseStyle, setEditPendingCSSText, setEditPendingMarkerStyle, setEditProxyConstructor, setEditSelectionType, setEditSummaryFieldText, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValues, setEmbeddedComponentIndent, setEmbeddedComponentMargin, setEmptyAIHoverContents, setEmptyCellValue, setEmptyMessage, setEmptyMessageStyle, setEmptyRowRangeDisplayValue, setEnforceVClipping, setEnterKeyEditAction, setEnumCriteriaAsInitialValues, setErrorIconHeight, setErrorIconSrc, setErrorIconWidth, setEscapeKeyEditAction, setExactRowCountFormat, setExpansionCanEdit, setExpansionComponentPoolingMode, setExpansionEditorSaveDialogPrompt, setExpansionEditorShowSaveDialog, setExpansionFieldFalseImage, setExpansionFieldImageHeight, setExpansionFieldImageShowRTL, setExpansionFieldImageShowSelected, setExpansionFieldImageStyle, setExpansionFieldImageWidth, setExpansionFieldTrueImage, setExpansionIndent, setExpansionMode, setExpansionScreen, setExplicitFetchDelay, setExportAll, setExportAlternateRowBGColor, setExportColumnWidthPadding, setExportDefaultBGColor, setExportFieldAlignments, setExportFields, setExportFieldWidths, setExportHeaderHeights, setExportHiddenFieldWidth, setExportIncludeSummaries, setExportRawNumbers, setExportRawValues, setExportWidthScale, setExportWrapCells, setExportWrapHeaderTitles, setFastCellUpdates, setFetchDelay, setFetchFields, setFetchFields, setFetchOperation, setFetchRequestProperties, setFieldAlign, setFieldButtonProperties, setFieldCellAlign, setFieldCellIcon, setFieldCriteriaText, setFieldError, setFieldError, setFieldHeaderBaseStyle, setFieldHeaderTitleStyle, setFieldIcon, setFieldMaxWidth, setFieldMinWidth, setFieldPickerFieldProperties, setFieldPickerShowSampleValues, setFieldProperties, setFieldProperties, setFields, setFields, setFieldSearchOperator, setFieldState, setFieldTitle, setFieldTitle, setFieldVisibilitySubmenuTitle, setFilterButtonPrompt, setFilterButtonProperties, setFilterByCell, setFilterEditorCriteria, setFilterEditorHeight, setFilterEditorProperties, setFilterEditorProperties, setFilterLocalData, setFilterOnKeypress, setFilterUsingText, setFilterViaAIMode, setFilterViaAIPanelInstructions, setFilterViaAIText, setFilterWindowCriteria, setFilterWindowInstructions, setFilterWindowTitle, setFirstCellStyle, setFixedFieldWidths, setFixedRecordHeights, setFormulaBuilderSpanTitleSeparator, setFreezeFieldText, setFrozenBaseStyle, setFrozenBodyStyleName, setFrozenFieldsMaxWidth, setFrozenFieldsMaxWidth, setFrozenHeaderBaseStyle, setFrozenHeaderTitleStyle, setFullRowRangeDisplayValue, setGenerateClickOnEnter, setGenerateClickOnSpace, setGenerateDoubleClickOnEnter, setGenerateDoubleClickOnSpace, setGridAdditionalCriteriaText, setGridComponents, setGridComponents, setGridComponents, setGridSummaryRecordProperty, setGroupByAsyncThreshold, setGroupByFieldSummaries, setGroupByMaxRecords, setGroupByMaxRecordsExceededMessage, setGroupByText, setGroupIcon, setGroupIconSize, setGroupIconStyle, setGroupIndentSize, setGroupLeadingIndent, setGroupNodeBaseStyle, setGroupNodeStyle, setGroupSortDirection, setGroupSortNormalizer, setGroupStartOpen, setGroupStartOpen, setGroupState, setGroupSummaryRecordProperty, setGroupSummaryStyle, setGroupTitleColumnProperties, setGroupTitleField, setHeaderAriaRole, setHeaderAutoFitEvent, setHeaderBackgroundColor, setHeaderBarStyle, setHeaderBaseStyle, setHeaderButtonAriaRole, setHeaderButtonAriaState, setHeaderButtonProperties, setHeaderHeight, setHeaderHoverAlign, setHeaderHoverFormatter, setHeaderHoverHeight, setHeaderHoverOpacity, setHeaderHoverStyle, setHeaderHoverVAlign, setHeaderHoverWidth, setHeaderHoverWrap, setHeaderMenuButtonHeight, setHeaderMenuButtonHeight, setHeaderMenuButtonIcon, setHeaderMenuButtonIconHeight, setHeaderMenuButtonIconWidth, setHeaderMenuButtonSnapOffsetLeft, setHeaderMenuButtonWidth, setHeaderRadius, setHeaderShadowColor, setHeaderShadowHOffset, setHeaderShadowSoftness, setHeaderShadowVOffset, setHeaderSpanBaseStyle, setHeaderSpanButtonProperties, setHeaderSpanHeaderTitle, setHeaderSpanHeight, setHeaderSpans, setHeaderSpanTitle, setHeaderSpanTitleStyle, setHeaderTitleStyle, setHeaderTitleVAlign, setHideEmptySummaryRow, setHideFilterEditorTitle, setHideOnPhone, setHideOnTablet, setHiliteCanReplaceValue, setHiliteEditorSpanTitleSeparator, setHiliteHTMLAfterFormat, setHiliteIconHeight, setHiliteIconLeftPadding, setHiliteIconPosition, setHiliteIconRightPadding, setHiliteIcons, setHiliteIconSize, setHiliteIconWidth, setHiliteProperty, setHiliteReplaceValueFieldTitle, setHiliteRowOnFocus, setHilites, setHiliteState, setHiliteViaAIMode, setHiliteViaAIText, setHoverCustomizer, setHoverMode, setHoverScreen, setHoverStyle, setIconCursor, setImageSize, setImplicitCriteria, setImplicitCriteria, setImplicitCriteria, setInactiveCellFormatter, setIncludeHilitesInSummaryFields, setIncludeInSummaryProperty, setInitialCriteria, setInitialSort, setInlineEditItemGap, setInstantScrollTrackRedraw, setInvalidSummaryValue, setIsSeparatorProperty, setLastCellStyle, setLeaveHeaderMenuButtonSpace, setLeaveScrollbarGap, setLinkTextProperty, setLinkTextStyleName, setListEndEditAction, setLoadingDataMessage, setLoadingDataMessageStyle, setLoadingMessage, setLoadingRowCountDisplayIcoHeight, setLoadingRowCountDisplayIcon, setLoadingRowCountDisplayIconWidth, setLocateColumnsBy, setLocateRowsBy, setLogicalStructure, setLongTextEditorThreshold, setLongTextEditorType, setMaxExpandedRecords, setMaxExpandedRecordsPrompt, setMaximumRowCountFormat, setMaxSummaryRowRecords, setMinFieldWidth, setMinHeight, setMinimumCellHeight, setMinimumRowCountFormat, setMissingSummaryFieldValue, setModalEditing, setMultiGroupDialogDefaults, setMultiGroupDialogProperties, setMultiSortDialogDefaults, setMultiSortDialogProperties, setNavigateOnTab, setNeverValidate, setNewRecordRowMessage, setNewSearchText, setNormalBaseStyle, setNormalCellHeight, setNoSavedSearchesText, setNullGroupTitle, setOfflineMessageStyle, setOriginBaseStyle, setOverflow, setPendingAsyncCellValue, setPlaceholderAIHoverContents, setPoolComponentsPerColumn, setPreRender, setPreRenderDelay, setPreRenderFormatValues, setPreRenderImageMode, setPreRenderPlaceholderColor, setPreRenderStructureDelay, setPreRenderTransitionDuration, setPreRenderTransitionFrameDefaults, setPreserveFocusStylingOnMouseOut, setPreserveWhitespace, setPreventDuplicates, setPrintAutoFit, setPrintBaseStyle, setPrintBooleanBaseStyle, setPrintBooleanFalseImage, setPrintBooleanPartialImage, setPrintBooleanTrueImage, setPrintCheckboxFieldFalseImage, setPrintCheckboxFieldPartialImage, setPrintCheckboxFieldTrueImage, setPrintHeaderStyle, setPrintMaxRows, setPrintWrapCells, setProgressiveLoading, setQuickDrawAheadRatio, setRangeRowCountFormat, setRecordBaseStyleProperty, setRecordCanRemoveProperty, setRecordCanSelectProperty, setRecordCellRoleProperty, setRecordComponentHeight, setRecordComponentPoolingMode, setRecordComponentPosition, setRecordDetailDSProperty, setRecordEditProperty, setRecordEnabledProperty, setRecordRadius, setRecordRadiusTargets, setRecordRowAriaStateProperty, setRecordRowRoleProperty, setRecords, setRecordScreen, setRecordShowRollOverProperty, setRecordSummaryAttributePrefix, setRecordSummaryBaseStyle, setRemovedCSSText, setRemoveFieldProperties, setRemoveFieldTitle, setRemoveIcon, setRemoveIconSize, setRemoveIconStyle, setRemoveOperation, setReselectOnUpdate, setReselectOnUpdateNotifications, setResizeFieldsInRealTime, setReverseRTLAlign, setRollOverCanvasProperties, setRollUnderCanvasProperties, setRotatedHeaderMenuButtonHeight, setRotatedHeaderMenuButtonHeight, setRotatedHeaderMenuButtonWidth, setRotateHeaderTitles, setRowAriaState, setRowCountDisplayPrecision, setRowEndEditAction, setRowErrors, setRowErrors, setRowLocatorField, setRowLocatorField, setRowNumberFieldProperties, setRowNumberStart, setRowNumberStyle, setRowRangeDisplayStyle, setRowRangeFormat, setRowRole, setRowSpanEditMode, setRowSpanSelectionMode, setSaveByCell, setSaveCriteriaInViewState, setSaveDefaultSearch, setSavedSearchAdminRole, setSavedSearchDS, setSavedSearchId, setSavedSearchStoredState, setSavedSearchText, setSaveLocally, setSaveRequestProperties, setScreenReaderCellSeparator, setScreenReaderIncludeFieldTitles, setScreenReaderNavigateByCell, setScreenReaderRowSeparator, setScreenReaderWriteRowLabelledBy, setScrollRedrawDelay, setScrollToCellXPosition, setScrollToCellYPosition, setScrollWheelRedrawDelay, setSearchForm, setSearchForm, setSearchForm, setSelectCellTextOnClick, setSelectedState, setSelectHeaderOnSort, setSelectionAppearance, setSelectionCanvasProperties, setSelectionType, setSelectionUnderCanvasProperties, setSelectOnEdit, setSelectOnExpandRecord, setSeparatorRowStyle, setShowAllColumns, setShowAllRecords, setShowAsynchGroupingPrompt, setShowBackgroundComponents, setShowCellContextMenus, setShowClippedHeaderTitlesOnHover, setShowClippedValuesOnHover, setShowCollapsedGroupSummary, setShowComplexFields, setShowDetailFields, setShowDropLines, setShowDropOverRollOver, setShowEllipsisWhenClipped, setShowEmptyMessage, setShowErrorIcons, setShowFilterEditor, setShowFilterEditorHovers, setShowFilterEditorTitle, setShowFilterWindowCriteriaIndicator, setShowGridSummary, setShowGroupSummary, setShowGroupSummaryInHeader, setShowGroupTitleColumn, setShowGroupTitleInFrozenBody, setShowHeader, setShowHeaderContextMenu, setShowHeaderMenuButton, setShowHeaderPartialSelection, setShowHeaderSeparators, setShowHeaderShadow, setShowHeaderSpanContextMenu, setShowHeaderSpanTitlesInFormulaBuilder, setShowHeaderSpanTitlesInHiliteEditor, setShowHeaderSpanTitlesInSortEditor, setShowHiddenFields, setShowHilitesInGroupSummary, setShowHover, setShowHoverComponents, setShowHoverOnDisabledCells, setShowInitialDragHandles, setShowLastHeaderSeparators, setShowNewRecordRow, setShowPreRenderTransition, setShowRecordComponents, setShowRecordComponentsByCell, setShowRollOver, setShowRollOverCanvas, setShowRollOverInExpansion, setShowRollUnderCanvas, setShowRowNumbers, setShowSavedSearchesByDS, setShowSelectedRollOverCanvas, setShowSelectedRollUnderCanvas, setShowSelectedStyle, setShowSelectionCanvas, setShowSelectionUnderCanvas, setShowSortArrow, setShowSortNumerals, setShowTreeColumnPicker, setShrinkForFreeze, setSingleCellValueProperty, setSkinImgDir, setSkipClipDiv, setSkipLineBreaks, setSort, setSortArrowMenuButtonSpaceOffset, setSortAscendingImage, setSortAscendingImage, setSortBinaryByFileName, setSortByGroupFirst, setSortDescendingImage, setSortDescendingImage, setSortDirection, setSortEditorSpanTitleSeparator, setSorterButtonTitle, setSortField, setSortField, setSortField, setSortFieldAscendingText, setSortFieldDescendingText, setSortNumeralHTMLCustomizer, setSortNumeralMenuButtonSpaceOffset, setSortNumeralStyle, setSortState, setSpannedHeaderBaseStyle, setSparseFieldState, setStopOnErrors, setStyledRowEnds, setStyleName, setSummaryRowCriteria, setSummaryRowDataSource, setSummaryRowFetchRequestProperties, setSummaryRowHeight, setSummaryRowStyle, setTableRowStyle, setTallBaseStyle, setTitleField, setTouchScrollRedrawDelay, setTrackerImage, setTrackerImage, setUnfreezeFieldText, setUngroupText, setUnknownRowCountDisplayValue, setUnremoveIcon, setUpdateOperation, setUpdateSummariesDuringEditing, setUseAdvancedCriteria, setUseAdvancedFieldPicker, setUseCellRollOvers, setUseClientFiltering, setUseFlatFields, setUseInlineEditors, setUseInlineFilterEditors, setUseLegacyDefaultFormattedValue, setUseMultiSelectForFilterValueMaps, setUserCriteriaState, setUseRemoteValidators, setUserFormula, setUserFormula, setUserFormula, setUserFormula, setUserFormulaText, setUserFormulaText, setUserFormulaText, setUserFormulaText, setUseRowSpanStyling, setUserSummary, setUserSummary, setUserSummary, setUserSummary, setUserSummaryText, setUserSummaryText, setUserSummaryText, setUserSummaryText, setValidateByCell, setValidateOnChange, setValueIconHeight, setValueIconLeftPadding, setValueIconRightPadding, setValueIconSize, setValueIconWidth, setValueMap, setValueMap, setViewState, setVirtualScrolling, setWaitForSave, setWarnOnRemoval, setWarnOnRemovalMessage, setWarnOnUnmappedValueFieldChange, setWrapCells, setWrapHeaderSpanTitles, setWrapHeaderTitles, shouldIncludeHiliteInSummaryField, showAIFilterWindow, showAIHiliteWindow, showDragHandles, showField, showField, showFields, showFields, showFields, showFields, showFilterWindow, showRecordComponent, sort, sort, sort, sort, startEditing, startEditing, startEditing, startEditing, startEditingNew, startEditingNew, startEditingNew, stopHover, summaryUpdated, toggleSort, transferRecords, transferSelectedData, transferSelectedData, unfreezeField, unfreezeField, unfreezeField, unfreezeField, unfreezeFields, unfreezeFields, ungroup, unmarkRecordRemoved, unsort, updateData, updateData, updateData, updateRecordComponent, userSelectAllRecords, validateCell, validateCell, validateRow, willFetchData, willFetchData`

  ### Methods inherited from class com.smartgwt.client.widgets.layout.VLayout

  `setDefaultProperties, setLogicalStructure`

  ### Methods inherited from class com.smartgwt.client.widgets.layout.Layout

  `addMember, addMember, addMember, addMember, addMemberPostCreate, addMemberPostCreate, addMemberPreCreate, addMemberPreCreate, addMembers, addMembers, addMembersChangedHandler, getAnimateMembers, getAnimateMemberTime, getCanDropComponents, getChildTabPosition, getDefaultResizeBars, getDropComponent, getDropLine, getDropLineThickness, getDropPosition, getEnforcePolicy, getHPolicy, getLayoutBottomMargin, getLayoutEndMargin, getLayoutLeftMargin, getLayoutMargin, getLayoutRightMargin, getLayoutStartMargin, getLayoutTopMargin, getLocateMembersBy, getLocateMembersType, getManagePercentBreadth, getMember, getMember, getMemberDefaultBreadth, getMemberNumber, getMemberNumber, getMemberOverlap, getMembers, getMembersAsStringArray, getMembersLength, getMembersMargin, getMinMemberLength, getMinMemberSize, getPaddingAsLayoutMargin, getResizeBar, getResizeBarClass, getResizeBarSize, getReverseOrder, getShowDragPlaceHolder, getStackZIndex, getVertical, getVPolicy, hasMember, hideDropLine, hideMember, hideMember, layoutIsDirty, onInit_Layout, reflow, reflow, reflowNow, removeMember, removeMembers, removeMembers, reorderMember, reorderMembers, replaceMember, revealChild, revealChild, setAlign, setAlign, setAnimateMembers, setAnimateMemberTime, setCanDropComponents, setDefaultLayoutAlign, setDefaultLayoutAlign, setDefaultProperties, setDefaultResizeBars, setDropLineProperties, setDropLineThickness, setEnforcePolicy, setHPolicy, setLayoutBottomMargin, setLayoutEndMargin, setLayoutLeftMargin, setLayoutMargin, setLayoutRightMargin, setLayoutStartMargin, setLayoutTopMargin, setLocateMembersBy, setLocateMembersType, setLogicalStructure, setManagePercentBreadth, setMemberOverlap, setMembers, setMembers, setMembersMargin, setMinBreadthMember, setMinBreadthMember, setMinBreadthMember, setMinMemberLength, setMinMemberSize, setPaddingAsLayoutMargin, setPlaceHolderDefaults, setPlaceHolderProperties, setResizeBarClass, setResizeBarSize, setReverseOrder, setShowDragPlaceHolder, setStackZIndex, setVertical, setVisibleMember, setVPolicy, showMember, showMember`

  ### Methods inherited from class com.smartgwt.client.widgets.Canvas

  `addChild, addChild, addChild, addChild, addChild, addClearHandler, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addRuleContextChangedHandler, addScrolledHandler, addShowContextMenuHandler, addSnapAlignCandidate, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clearExplicitTabIndex, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsEventTarget, containsFocus, containsPoint, containsPoint, contentsComponentConnected, dataContextChanged, dataContextCriteriaChanged, deparent, depeer, disable, doValueDictation, doVoiceCommand, enable, encloses, endBatchCreation, focus, focusAfterGroup, focusAtEnd, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAdaptiveHeightPriority, getAdaptiveWidthPriority, getAllCanvases, getAllCanvases, getAllCanvases, getAlwaysManageFocusNavigation, getAlwaysShowScrollbars, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideEffect, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeLayoutMode, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaHandleID, getAutoMaskComponents, getAutoParent, getAutoPopulateData, getAutoRevertStyles, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBorderRadius, getBorderRadiusAsString, getBottom, getById, getByJSObject, getByLocalId, getCanAcceptDrop, getCanAdaptHeight, getCanAdaptWidth, getCanDrag, getCanDragReposition, getCanDragResize, getCanDragScroll, getCanDrop, getCanDropBefore, getCanDropContent, getCanDropFiles, getCanFocus, getCanSelectText, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenAsStringArray, getChildrenResizeSnapAlign, getChildrenSnapAlign, getChildrenSnapCenterAlign, getChildrenSnapEdgeAlign, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getClassName, getComponentMask, getComponentMaskDefaults, getContentElement, getContents, getContentsComponentDefaults, getContextMenu, getControlHeight, getCorrectZoomOverflow, getCursor, getDataContext, getDataContextCriteria, getDataContextCriteria, getDataPath, getDefaultHeight, getDefaultWidth, getDeferActionConversion, getDefiningProperty, getDefiningPropertyName, getDefiningPropertyNameOptions, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDisableTouchScrollingForDrag, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragMaskType, getDragMaxHeight, getDragMaxWidth, getDragMinHeight, getDragMinWidth, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragTargetAsString, getDragType, getDropTarget, getDropTargetAsString, getDropTypes, getDropTypesAsString, getDynamicContents, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getEditNode, getEditProxy, getElement, getElement, getEnableWhen, getEndLine, getEventEdge, getEventEdge, getEvents, getExtraSpace, getFacetId, getFloatingScrollbars, getFormItemAutoChild, getForwardSVGeventsToObject, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupPadding, getGroupTitle, getHeight, getHeightAsString, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverAutoFitMaxWidth, getHoverAutoFitMaxWidthAsString, getHoverAutoFitWidth, getHoverComponent, getHoverDelay, getHoverFocusKey, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverPersist, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapPosition, getHSnapPosition, getHtmlElement, getHtmlElementAsString, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getIsPrinting, getIsRuleScope, getIsSnapAlignCandidate, getKeepInParentRect, getLayoutAlign, getLeaveGroupLabelSpace, getLeavePageSpace, getLeft, getLeftAsString, getLocalId, getLocateByIDOnly, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getLocatorName, getMargin, getMasterCanvas, getMasterElement, getMatchElement, getMatchElementHeight, getMatchElementWidth, getMaxHeight, getMaxWidth, getMaxZoomOverflowError, getMenuConstructor, getMinNonEdgeSize, getMinWidth, getMomentumScrollMinSpeed, getMouseStillDownDelay, getMouseStillDownInitialDelay, getName, getNativeAutoHideScrollbars, getNextZIndex, getNoDoubleClicks, getNoDropCursor, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOpacity, getOuterElement, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getPaletteDefaults, getPanelContainer, getParentCanvas, getParentCanvasAsString, getParentElement, getParentElementAsString, getPeers, getPendingMarkerStyle, getPendingMarkerVisible, getPercentBox, getPercentSource, getPersistentMatchElement, getPointerSettings, getPointerTarget, getPointerTargetAsString, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrintHTML, getPrintStyleName, getPrompt, getProportionalResizeModifiers, getProportionalResizing, getReceiveScrollbarEvents, getRect, getRedrawOnResize, getResizeBarTarget, getResizeFrom, getRight, getRuleContext, getRuleContext, getRuleScope, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowColor, getShadowDepth, getShadowHOffset, getShadowImage, getShadowOffset, getShadowSoftness, getShadowSpread, getShadowVOffset, getShareCriteria, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowEdges, getShowFocusOutline, getShowPointer, getShowResizeBar, getShowShadow, getShowSnapGrid, getShrinkElementOnHide, getSingleDiv, getSizeMayChangeOnRedraw, getSnapAlignCandidates, getSnapAlignCenterLineStyle, getSnapAlignEdgeLineStyle, getSnapAxis, getSnapEdge, getSnapGridLineProperties, getSnapGridStyle, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapPosition, getSnapPosition, getSnapResizeToAlign, getSnapResizeToGrid, getSnapTo, getSnapToAlign, getSnapToCenterAlign, getSnapToEdgeAlign, getSnapToGrid, getSnapVDirection, getSnapVGap, getStartLine, getSuppressRedraw, getTabIndex, getTestDataContext, getTitle, getTooltip, getTop, getTopAsString, getTopElement, getTopLevelComponents, getUpdateTabPositionOnDraw, getUpdateTabPositionOnReparent, getUseBackMask, getUseCSSShadow, getUseDataContextCriteria, getUseDragMask, getUseGeneratedStyles, getUseImageForSVG, getUseNativeDrag, getUseOpacityFilter, getUseTouchScrolling, getValuesManager, getValuesManagerAsString, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWhen, getVisibleWidth, getVSnapPosition, getVSnapPosition, getWidth, getWidthAsString, getWorkflows, getZIndex, getZIndex, handleDataContextCriteria, handleHover, hide, hideClickMask, hideClickMask, hideComponentMask, hideComponentMask, hideContextMenu, imgHTML, imgHTML, imgHTML, initComplete, intersects, isDirty, isDisabled, isFocused, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, pageScrollDown, pageScrollUp, parentResized, placeNear, placeNear, placeNear, print, print, print, print, printComponents, provideRuleContext, provideRuleContext, redraw, redraw, registerAIService, registerFontScaledPaddingStyles, removeChild, removeChild, removePeer, removePeer, removeRuleContext, removeSnapAlignCandidate, resizeAutoChildAttributes, resizeBy, resizeControls, resizeControlsTo, resizeFonts, resizeFonts, resizeFonts, resizeFontsTo, resizeIcons, resizePadding, resizePadding, resizeTo, resizeTo, resolveContentsComponent, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAdaptHeightByCustomizer, setAdaptiveHeightPriority, setAdaptiveWidthPriority, setAdaptWidthByCustomizer, setAllowExternalFilters, setAlwaysManageFocusNavigation, setAlwaysShowScrollbars, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideEffect, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeLayoutMode, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoHeight, setAutoMaskComponents, setAutoParent, setAutoPopulateData, setAutoResizeAutoChildAttributes, setAutoResizeIcons, setAutoRevertStyles, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBorderRadius, setBorderRadius, setBottom, setCanAcceptDrop, setCanAdaptHeight, setCanAdaptWidth, setCanDrag, setCanDragReposition, setCanDragResize, setCanDragScroll, setCanDrop, setCanDropBefore, setCanDropContent, setCanDropFiles, setCanFocus, setCanSelectText, setChildren, setChildrenResizeSnapAlign, setChildrenSnapAlign, setChildrenSnapCenterAlign, setChildrenSnapEdgeAlign, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setComponentMaskDefaults, setContents, setContentsComponentDefaults, setContextMenu, setCorrectZoomOverflow, setCursor, setDataContext, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataPath, setDefaultHeight, setDefaultNativeAutoHideScrollbars, setDefaultPageSpace, setDefaultProperties, setDefaultShowCustomScrollbars, setDefaultWidth, setDeferActionConversion, setDefiningProperty, setDefiningPropertyNameOptions, setDisabled, setDisabledCursor, setDisableTouchScrollingForDrag, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragMaskType, setDragMaxHeight, setDragMaxWidth, setDragMinHeight, setDragMinWidth, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragTarget, setDragType, setDropTarget, setDropTarget, setDropTypes, setDropTypes, setDynamicContents, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setEditMode, setEditMode, setEditMode, setElement, setEnableWhen, setEndLine, setExtraSpace, setFacetId, setFloatingScrollbars, setForwardSVGeventsToObject, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupPadding, setGroupTitle, setHeight, setHeight, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverAutoFitMaxWidth, setHoverAutoFitMaxWidth, setHoverAutoFitWidth, setHoverDelay, setHoverFocusKey, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverPersist, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlElement, setHtmlElement, setHtmlPosition, setImage, setImage, setInitHandler, setIsGroup, setIsRuleScope, setIsSnapAlignCandidate, setKeepInParentRect, setKeepInParentRect, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeaveGroupLabelSpace, setLeavePageSpace, setLeft, setLeft, setLocateByIDOnly, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLocatorName, setLocatorParent, setLocatorParent, setLogicalStructure, setMargin, setMatchElement, setMatchElementHeight, setMatchElementWidth, setMaxHeight, setMaxWidth, setMaxZoomOverflowError, setMenuConstructor, setMinNonEdgeSize, setMinWidth, setMomentumScrollMinSpeed, setMouseStillDownDelay, setMouseStillDownInitialDelay, setName, setNativeAutoHideScrollbars, setNeverUseFilters, setNoDoubleClicks, setNoDropCursor, setOpacity, setPadding, setPageLeft, setPageTop, setPanelContainer, setParentCanvas, setParentCanvas, setParentElement, setParentElement, setPeers, setPendingMarkerStyle, setPendingMarkerVisible, setPercentBox, setPercentSource, setPersistentMatchElement, setPointerSettings, setPointerTarget, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrintStyleName, setPrompt, setProportionalResizeModifiers, setProportionalResizing, setReceiveScrollbarEvents, setRect, setRect, setRedrawOnResize, setRelativeTabPosition, setResizeBarTarget, setResizeFrom, setResizeFrom, setRight, setRuleScope, setScrollbarConstructor, setScrollbarSize, setShadowColor, setShadowDepth, setShadowHOffset, setShadowImage, setShadowOffset, setShadowSoftness, setShadowSpread, setShadowVOffset, setShareCriteria, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowEdges, setShowFocusOutline, setShowPointer, setShowResizeBar, setShowShadow, setShowSnapGrid, setShrinkElementOnHide, setSingleDiv, setSizeMayChangeOnRedraw, setSmoothFade, setSnapAlignCandidates, setSnapAlignCenterLineStyle, setSnapAlignEdgeLineStyle, setSnapAxis, setSnapEdge, setSnapGridLineProperties, setSnapGridStyle, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToAlign, setSnapResizeToGrid, setSnapTo, setSnapToAlign, setSnapToCenterAlign, setSnapToEdgeAlign, setSnapToGrid, setSnapVDirection, setSnapVGap, setStartLine, setSuppressRedraw, setTabIndex, setTestDataContext, setTitle, setTooltip, setTop, setTop, setUpdateTabPositionOnDraw, setUpdateTabPositionOnReparent, setUseBackMask, setUseCSSShadow, setUseDataContextCriteria, setUseDragMask, setUseGeneratedStyles, setUseImageForSVG, setUseNativeDrag, setUseOpacityFilter, setUseTouchScrolling, setValuesManager, setValuesManager, setVisibility, setVisible, setVisibleWhen, setWidth, setWidth, setWidth, setWidth100, setWorkflows, setZIndex, shouldDragScroll, show, showClickMask, showComponentMask, showComponentMask, showNextTo, showNextTo, showNextTo, showNextTo, showPendingMarker, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, startBatchCreation, startDebuggingOverflow, stopDebuggingOverflow, subtractRects, supportsValueDictation, supportsVoiceCommands, unregisterAIService, updateChildTabPosition, updateChildTabPositions, updateEditNode, updateHover, updateHover, updateShadow, updateTabPositionForDraw, visibleAtPoint`

  ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

  `addDrawHandler, addDynamicProperty, addDynamicProperty, addDynamicProperty, addDynamicProperty, applyFactoryProperties, clearDynamicProperty, completeCreation, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getAutoDraw, getConfig, getDOM, getHandlerCount, getID, getInnerHTML, getJsObj, getOrCreateJsObj, getRef, getScClassName, hasAutoAssignedID, hasDynamicProperty, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, isDrawn, isFactoryCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAutoDraw, setConfig, setConfigOnly, setDefaultProperties, setDragTracker, setFactoryCreated, setID, setJavaScriptObject, setLogicalStructure, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

  ### Methods inherited from class com.google.gwt.user.client.ui.Widget

  `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents, unsinkEvents`

  ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

  `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.smartgwt.client.widgets.DataBoundComponent

  `getOrCreateJsObj`

  ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

  `fireEvent`

- ## Constructor Details

  - ### EditTree

    public EditTree()

  - ### EditTree

    public EditTree(JavaScriptObject jsObj)

- ## Method Details

  - ### getOrCreateRef

    public static EditTree getOrCreateRef(JavaScriptObject jsObj)

  - ### changeAutoChildDefaults

    public static void changeAutoChildDefaults(String autoChildName, Canvas defaults)
    Changes the defaults for Canvas AutoChildren named `autoChildName`.
    Parameters:
      `autoChildName` - name of an AutoChild to customize the defaults for.
      `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
    See Also:
      - `AutoChildUsage`

  - ### changeAutoChildDefaults

    public static void changeAutoChildDefaults(String autoChildName, FormItem defaults)
    Changes the defaults for FormItem AutoChildren named `autoChildName`.
    Parameters:
      `autoChildName` - name of an AutoChild to customize the defaults for.
      `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
    See Also:
      - `AutoChildUsage`

  - ### create

    protected JavaScriptObject create()
    Overrides:
      `create` in class `TreeGrid`

  - ### setAllowNestedDrops

    public EditTree setAllowNestedDrops(Boolean allowNestedDrops) throws IllegalStateException
    Controls whether components can be dropped into other components which support child components.

    When enabled, during a drop interaction in which a `PaletteNode` or `EditNode` is the drop data, the `Component Schema` of the current candidate drop target is inspected to see whether that parent allows children of the type being dropped. If it does, the drop will result in a call to `addNode()` for a paletteNode or for an existing `EditNode` in the same tree.

    Specific components can disable nested drops by explicitly setting `EditProxy.allowNestedDrops` to false.

    This mode is enabled by default unless explicitly disabled by setting this property to false.

    Parameters:
      `allowNestedDrops` - New allowNestedDrops value. Default value is null
    Returns:
      `EditTree` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getAllowNestedDrops

    public Boolean getAllowNestedDrops()
    Controls whether components can be dropped into other components which support child components.

    When enabled, during a drop interaction in which a `PaletteNode` or `EditNode` is the drop data, the `Component Schema` of the current candidate drop target is inspected to see whether that parent allows children of the type being dropped. If it does, the drop will result in a call to `addNode()` for a paletteNode or for an existing `EditNode` in the same tree.

    Specific components can disable nested drops by explicitly setting `EditProxy.allowNestedDrops` to false.

    This mode is enabled by default unless explicitly disabled by setting this property to false.

    Returns:
      Current allowNestedDrops value. Default value is null

  - ### setAutoEditNewNodes

    public EditTree setAutoEditNewNodes(Boolean autoEditNewNodes) throws IllegalStateException
    New nodes added to the editContext are automatically placed into edit mode if the new node's parent is in edit mode. To suppress this action set `autoEditNewNodes` to false.
    Parameters:
      `autoEditNewNodes` - New autoEditNewNodes value. Default value is null
    Returns:
      `EditTree` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getAutoEditNewNodes

    public Boolean getAutoEditNewNodes()
    New nodes added to the editContext are automatically placed into edit mode if the new node's parent is in edit mode. To suppress this action set `autoEditNewNodes` to false.
    Returns:
      Current autoEditNewNodes value. Default value is null

  - ### setCanDragGroup

    public EditTree setCanDragGroup(Boolean canDragGroup) throws IllegalStateException
    Should the group selection box shown when `canGroupSelect` is true allow dragging the group as a whole?

    Treated as `true` if not set and `canGroupSelect` is true.

    Parameters:
      `canDragGroup` - New canDragGroup value. Default value is null
    Returns:
      `EditTree` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getCanDragGroup

    public Boolean getCanDragGroup()
    Should the group selection box shown when `canGroupSelect` is true allow dragging the group as a whole?

    Treated as `true` if not set and `canGroupSelect` is true.

    Returns:
      Current canDragGroup value. Default value is null

  - ### setCanGroupSelect

    public EditTree setCanGroupSelect(Boolean canGroupSelect) throws IllegalStateException
    Should a group selection outline covering the outermost bounding boxes of all selected components be shown in this container?

    Treated as `true` if not set and hoop selection is enabled (see `EditProxy.canSelectChildren` and `selectionType`.

    Parameters:
      `canGroupSelect` - New canGroupSelect value. Default value is null
    Returns:
      `EditTree` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getCanGroupSelect

    public Boolean getCanGroupSelect()
    Should a group selection outline covering the outermost bounding boxes of all selected components be shown in this container?

    Treated as `true` if not set and hoop selection is enabled (see `EditProxy.canSelectChildren` and `selectionType`.

    Returns:
      Current canGroupSelect value. Default value is null

  - ### setCanSaveSearches

    public EditTree setCanSaveSearches(boolean canSaveSearches) throws IllegalStateException
    Option to save searches is disabled for editTree

    Note : This is an advanced setting

    Overrides:
      `setCanSaveSearches` in class `ListGrid`
    Parameters:
      `canSaveSearches` - New canSaveSearches value. Default value is false
    Returns:
      `EditTree` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getCanSaveSearches

    public boolean getCanSaveSearches()
    Option to save searches is disabled for editTree
    Overrides:
      `getCanSaveSearches` in class `ListGrid`
    Returns:
      Current canSaveSearches value. Default value is false

  - ### setCanShowFilterEditor

    public EditTree setCanShowFilterEditor(boolean canShowFilterEditor) throws IllegalStateException
    Option to show filter editor is disabled for editTree

    Note : This is an advanced setting

    Overrides:
      `setCanShowFilterEditor` in class `ListGrid`
    Parameters:
      `canShowFilterEditor` - New canShowFilterEditor value. Default value is false
    Returns:
      `EditTree` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `ListGrid.setShowFilterEditorTitle(java.lang.String)`
      - `ListGrid.setHideFilterEditorTitle(java.lang.String)`
      - Filter Example

  - ### getCanShowFilterEditor

    public boolean getCanShowFilterEditor()
    Option to show filter editor is disabled for editTree
    Overrides:
      `getCanShowFilterEditor` in class `ListGrid`
    Returns:
      Current canShowFilterEditor value. Default value is false
    See Also:
      - `ListGrid.getShowFilterEditorTitle()`
      - `ListGrid.getHideFilterEditorTitle()`
      - Filter Example

  - ### setDefaultPalette

    public EditTree setDefaultPalette(Palette defaultPalette) throws IllegalStateException
    `Palette` to use when an `EditNode` is being created directly by this EditContext, instead of being created due to a user interaction with a palette (eg dragging from a `TreePalette`, or clicking on `MenuPalette`).

    If no defaultPalette is provided, the EditContext uses an automatically created `HiddenPalette`.
    If this method is called after the component has been drawn/initialized: `Palette` to use when an `EditNode` is being created directly by this EditContext, instead of being created due to a user interaction with a palette (eg dragging from a `TreePalette`, or clicking on `MenuPalette`).

    If no defaultPalette is provided, the EditContext uses an automatically created `HiddenPalette`.

    Parameters:
      `defaultPalette` - the default Palette. Default value is null
    Returns:
      `EditTree` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getDefaultPalette

    public Palette getDefaultPalette()
    `Palette` to use when an `EditNode` is being created directly by this EditContext, instead of being created due to a user interaction with a palette (eg dragging from a `TreePalette`, or clicking on `MenuPalette`).

    If no defaultPalette is provided, the EditContext uses an automatically created `HiddenPalette`.

    Returns:
      `Palette` to use when an `EditNode` is being created directly by this EditContext, instead of being created due to a user interaction with a palette (eg dragging from a `TreePalette`, or clicking on `MenuPalette`).

      If no defaultPalette is provided, the EditContext uses an automatically created `HiddenPalette`. Default value is null

  - ### setEditContext

    public EditTree setEditContext(EditContext editContext) throws IllegalStateException
    The `EditContext` managed by this EditTree. If not set an instance will be automatically created.
    Parameters:
      `editContext` - New editContext value. Default value is null
    Returns:
      `EditTree` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getEditContext

    public EditContext getEditContext()
    The `EditContext` managed by this EditTree. If not set an instance will be automatically created.
    Returns:
      Returns the `EditContext` instance managed by the EditTree. Default value is null

  - ### setExtraPalettes

    public EditTree setExtraPalettes(Palette... extraPalettes) throws IllegalStateException
    Additional `Palettes` to consult for metadata when deserializing `Edit Nodes`. Note that the `defaultPalette` is always consulted and need not be provided again here.
    Parameters:
      `extraPalettes` - New extraPalettes value. Default value is null
    Returns:
      `EditTree` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getExtraPalettes

    public Palette[] getExtraPalettes()
    Additional `Palettes` to consult for metadata when deserializing `Edit Nodes`. Note that the `defaultPalette` is always consulted and need not be provided again here.
    Returns:
      Current extraPalettes value. Default value is null

  - ### setHideGroupBorderOnDrag

    public EditTree setHideGroupBorderOnDrag(Boolean hideGroupBorderOnDrag) throws IllegalStateException
    Should the group selection box shown when `canGroupSelect` is true be hidden during drag?

    Treated as `true` if not explicitly set to false.

    Parameters:
      `hideGroupBorderOnDrag` - New hideGroupBorderOnDrag value. Default value is null
    Returns:
      `EditTree` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getHideGroupBorderOnDrag

    public Boolean getHideGroupBorderOnDrag()
    Should the group selection box shown when `canGroupSelect` is true be hidden during drag?

    Treated as `true` if not explicitly set to false.

    Returns:
      Current hideGroupBorderOnDrag value. Default value is null

  - ### setPersistCoordinates

    public EditTree setPersistCoordinates(Boolean persistCoordinates) throws IllegalStateException
    When enabled, changes to a `liveObject`'s position and size will be persisted to their `EditNodes` by default. This applies to both programmatic calls and user interaction (drag reposition or drag resize).

    This feature can be disabled by either setting this property or `EditProxy.persistCoordinates` to `false`. This property affects all nodes within the EditContext whereas the latter property affects children of a single node.

    In some use-cases, like Reify, coordinates should not be persisted except when a component explicitly enables this feature. By setting this property to `null` no component will persist coordinates of children unless `EditProxy.persistCoordinates` is explicitly set to `true`.

    Parameters:
      `persistCoordinates` - New persistCoordinates value. Default value is true
    Returns:
      `EditTree` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getPersistCoordinates

    public Boolean getPersistCoordinates()
    When enabled, changes to a `liveObject`'s position and size will be persisted to their `EditNodes` by default. This applies to both programmatic calls and user interaction (drag reposition or drag resize).

    This feature can be disabled by either setting this property or `EditProxy.persistCoordinates` to `false`. This property affects all nodes within the EditContext whereas the latter property affects children of a single node.

    In some use-cases, like Reify, coordinates should not be persisted except when a component explicitly enables this feature. By setting this property to `null` no component will persist coordinates of children unless `EditProxy.persistCoordinates` is explicitly set to `true`.

    Returns:
      Current persistCoordinates value. Default value is true

  - ### setRootComponent

    public EditTree setRootComponent(Record rootComponent) throws IllegalStateException
    Root of data to edit. Must contain the "type" property, with the name of a valid `schema` or nothing will be able to be dropped on this EditContext. A "liveObject" property representing the rootComponent is also suggested. Otherwise, a live object will be created from the palette node.

    Can be retrieved at any time. Use `getRootEditNode()` to retrieve the `EditNode` created from the rootComponent.

    Parameters:
      `rootComponent` - New rootComponent value. Default value is null
    Returns:
      `EditTree` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `Dashboards & Tools Framework Overview`

  - ### getRootComponent

    public Record getRootComponent()
    Root of data to edit. Must contain the "type" property, with the name of a valid `schema` or nothing will be able to be dropped on this EditContext. A "liveObject" property representing the rootComponent is also suggested. Otherwise, a live object will be created from the palette node.

    Can be retrieved at any time. Use `getRootEditNode()` to retrieve the `EditNode` created from the rootComponent.

    Returns:
      Current rootComponent value. Default value is null
    See Also:
      - `Dashboards & Tools Framework Overview`

  - ### setSelectedBorder

    public EditTree setSelectedBorder(String selectedBorder) throws IllegalStateException
    Set the CSS border to be applied to the selection outline of the selected components. This property is used when `EditProxy.selectedAppearance` is `outlineMask` or `outlineEdges`.

    This value is applied as a default to `EditProxy.selectedBorder`.

    Parameters:
      `selectedBorder` - New selectedBorder value. Default value is null
    Returns:
      `EditTree` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getSelectedBorder

    public String getSelectedBorder()
    Set the CSS border to be applied to the selection outline of the selected components. This property is used when `EditProxy.selectedAppearance` is `outlineMask` or `outlineEdges`.

    This value is applied as a default to `EditProxy.selectedBorder`.

    Returns:
      Current selectedBorder value. Default value is null

  - ### setSelectedLabelBackgroundColor

    public EditTree setSelectedLabelBackgroundColor(String selectedLabelBackgroundColor) throws IllegalStateException
    The background color for the selection outline label. The default is defined on `SelectionOutline`.

    This value is applied as a default to `EditProxy.selectedLabelBackgroundColor`.

    NOTE: A selected component label is only supported when `EditProxy.selectedAppearance` is "outlineEdges".

    Parameters:
      `selectedLabelBackgroundColor` - New selectedLabelBackgroundColor value. Default value is null
    Returns:
      `EditTree` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `EditContext.setShowSelectedLabel(java.lang.Boolean)`

  - ### getSelectedLabelBackgroundColor

    public String getSelectedLabelBackgroundColor()
    The background color for the selection outline label. The default is defined on `SelectionOutline`.

    This value is applied as a default to `EditProxy.selectedLabelBackgroundColor`.

    NOTE: A selected component label is only supported when `EditProxy.selectedAppearance` is "outlineEdges".

    Returns:
      Current selectedLabelBackgroundColor value. Default value is null
    See Also:
      - `EditContext.getShowSelectedLabel()`

  - ### setShowSelectedLabel

    public EditTree setShowSelectedLabel(Boolean showSelectedLabel) throws IllegalStateException
    Should the selection outline show a label for selected components? A component may also be highlighted with the selection outline and label to indicate the target of a drop. To suppress showing a label at any time set this property to `false`.

    To suppress labels during selection but still show them when targeted for a drop, see `EditContext.showSelectedLabelOnSelect`.

    NOTE: A selected component label is only supported when `EditProxy.selectedAppearance` is "outlineEdges".

    Parameters:
      `showSelectedLabel` - New showSelectedLabel value. Default value is null
    Returns:
      `EditTree` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getShowSelectedLabel

    public Boolean getShowSelectedLabel()
    Should the selection outline show a label for selected components? A component may also be highlighted with the selection outline and label to indicate the target of a drop. To suppress showing a label at any time set this property to `false`.

    To suppress labels during selection but still show them when targeted for a drop, see `EditContext.showSelectedLabelOnSelect`.

    NOTE: A selected component label is only supported when `EditProxy.selectedAppearance` is "outlineEdges".

    Returns:
      Current showSelectedLabel value. Default value is null

  - ### setUseCopyPasteShortcuts

    public EditTree setUseCopyPasteShortcuts(Boolean useCopyPasteShortcuts) throws IllegalStateException
    If set, auto-enables `EditProxy.useCopyPasteShortcuts` on the `EditProxy` for the `root editNode`. This works whether there is currently a root editNode or one is added later.
    Overrides:
      `setUseCopyPasteShortcuts` in class `ListGrid`
    Parameters:
      `useCopyPasteShortcuts` - New useCopyPasteShortcuts value. Default value is null
    Returns:
      `EditTree` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getUseCopyPasteShortcuts

    public Boolean getUseCopyPasteShortcuts()
    If set, auto-enables `EditProxy.useCopyPasteShortcuts` on the `EditProxy` for the `root editNode`. This works whether there is currently a root editNode or one is added later.
    Overrides:
      `getUseCopyPasteShortcuts` in class `ListGrid`
    Returns:
      Current useCopyPasteShortcuts value. Default value is null

  - ### addFromPaletteNode

    public EditNode addFromPaletteNode(PaletteNode paletteNode)
    Creates a new EditNode from a PaletteNode, using the `defaultPalette`. If you have an array of possibly inter-related PaletteNodes, then you should use `addFromPaletteNodes()` on the array instead, in order to preserve the relationships.
    Parameters:
      `paletteNode` - the palette node to use to create the new node
    Returns:
      the EditNode created from the paletteNode
    See Also:
      - `addFromPaletteNodes(com.smartgwt.client.tools.PaletteNode[])`

  - ### addFromPaletteNode

    public EditNode addFromPaletteNode(PaletteNode paletteNode, EditNode parentNode)
    Creates a new EditNode from a PaletteNode, using the `defaultPalette`. If you have an array of possibly inter-related PaletteNodes, then you should use `addFromPaletteNodes()` on the array instead, in order to preserve the relationships.
    Parameters:
      `paletteNode` - the palette node to use to create the new node
      `parentNode` - optional the parent node if the new node should appear under a specific parent
    Returns:
      the EditNode created from the paletteNode
    See Also:
      - `addFromPaletteNodes(com.smartgwt.client.tools.PaletteNode[])`

  - ### addFromPaletteNodes

    public EditNode[] addFromPaletteNodes(PaletteNode[] paletteNodes)
    Add the supplied `PaletteNodes` to the parentNode, preserving internal references from one supplied PaletteNode to another. This method should be used with an array of possibly inter-related PaletteNodes (for instance, those produced as a result of serialization via `serializeAllEditNodes()`) rather than calling `addFromPaletteNode()` on each individual PaletteNode.
    Parameters:
      `paletteNodes` - array of PaletteNodes
    Returns:
      an array of the EditNodes added to the parentNode
    See Also:
      - `addFromPaletteNode(com.smartgwt.client.tools.PaletteNode)`

  - ### addFromPaletteNodes

    public EditNode[] addFromPaletteNodes(PaletteNode[] paletteNodes, EditNode parentNode)
    Add the supplied `PaletteNodes` to the parentNode, preserving internal references from one supplied PaletteNode to another. This method should be used with an array of possibly inter-related PaletteNodes (for instance, those produced as a result of serialization via `serializeAllEditNodes()`) rather than calling `addFromPaletteNode()` on each individual PaletteNode.
    Parameters:
      `paletteNodes` - array of PaletteNodes
      `parentNode` - parent to add to (defaults to the root)
    Returns:
      an array of the EditNodes added to the parentNode
    See Also:
      - `addFromPaletteNode(com.smartgwt.client.tools.PaletteNode)`

  - ### addNode

    public EditNode addNode(EditNode newNode)
    Add a new `EditNode` to the EditContext, under the specified parent. If the parentNode is not provided it will be determined from `EditContext.defaultParent`.

    The EditContext will interrogate the parent and new nodes to determine what field within the parent allows a child of this type, and to find a method to add the newNode's liveObject to the parentNode's liveObject. The new relationship will then be stored in the tree of EditNodes.

    For example, when a Tab is dropped on a TabSet, the field TabSet.tabs is discovered as the correct target field via naming conventions, and the method TabSet.addTab() is likewise discovered as the correct method to add a Tab to a TabSet.

    Parameters:
      `newNode` - new node to be added
    Returns:
      newNodenode added

  - ### addNode

    public EditNode addNode(EditNode newNode, EditNode parentNode)
    See `addNode()`

  - ### addNode

    public EditNode addNode(EditNode newNode, EditNode parentNode, Integer index)
    See `addNode()`

  - ### addNode

    public EditNode addNode(EditNode newNode, EditNode parentNode, Integer index, String parentProperty)
    See `addNode()`

  - ### addNode

    public EditNode addNode(EditNode newNode, EditNode parentNode, Integer index, String parentProperty, Boolean skipParentComponentAdd)
    See `addNode()`

  - ### addNode

    public EditNode addNode(EditNode newNode, EditNode parentNode, Integer index, String parentProperty, Boolean skipParentComponentAdd, Boolean forceSingularFieldReplace)
    Add a new `EditNode` to the EditContext, under the specified parent. If the parentNode is not provided it will be determined from `EditContext.defaultParent`.

    The EditContext will interrogate the parent and new nodes to determine what field within the parent allows a child of this type, and to find a method to add the newNode's liveObject to the parentNode's liveObject. The new relationship will then be stored in the tree of EditNodes.

    For example, when a Tab is dropped on a TabSet, the field TabSet.tabs is discovered as the correct target field via naming conventions, and the method TabSet.addTab() is likewise discovered as the correct method to add a Tab to a TabSet.

    Parameters:
      `newNode` - new node to be added
      `parentNode` - parent to add the new node under.
      `index` - index within the parent's children array
      `parentProperty` - the property of the liveParent to which the new node should be added, if not auto-discoverable from the schema
      `skipParentComponentAdd` - whether to skip adding the liveObject to the liveParent (default false)
      `forceSingularFieldReplace` - whether to replace existing single field node if newNode liveObject is the same (default false)
    Returns:
      newNodenode added

  - ### addPaletteNodesFromJS

    public void addPaletteNodesFromJS(String jsCode)
    Add `PaletteNodes` from a JavaScript source representation.

    By default, components that have `global IDs` will not actually be allowed to take those global IDs - instead, only widgets that have one of the global IDs passed as the `globals` parameter will actually receive their global IDs. To override this behavior, pass the special value `ALL_GLOBALS` for the `globals` parameter.

    Parameters:
      `jsCode` - JavaScript code to eval.

  - ### addPaletteNodesFromJS

    public void addPaletteNodesFromJS(String jsCode, EditNode parentNode)
    See `addPaletteNodesFromJS()`

  - ### addPaletteNodesFromJS

    public void addPaletteNodesFromJS(String jsCode, EditNode parentNode, String[] globals)
    Add `PaletteNodes` from a JavaScript source representation.

    By default, components that have `global IDs` will not actually be allowed to take those global IDs - instead, only widgets that have one of the global IDs passed as the `globals` parameter will actually receive their global IDs. To override this behavior, pass the special value `ALL_GLOBALS` for the `globals` parameter.

    Parameters:
      `jsCode` - JavaScript code to eval.
      `parentNode` - parent node (defaults to the root)
      `globals` - widgets to allow to take their global IDs

  - ### addPaletteNodesFromJSON

    public void addPaletteNodesFromJSON(String jsonString)
    Recreate `EditNodes` from a JSON representation of `PaletteNodes` (possibly created by calling `serializeAllEditNodesAsJSON()` or `serializeEditNodesAsJSON()`.

    By default, components that have `global IDs` will not actually be allowed to take those global IDs - instead, only widgets that have one of the global IDs passed as the `globals` parameter will actually receive their global IDs. To override this behavior, pass the special value `ALL_GLOBALS` for the `globals` parameter.

    Parameters:
      `jsonString` - JSON string representing an array of PaletteNodes
    See Also:
      - `addFromPaletteNodes(com.smartgwt.client.tools.PaletteNode[])`
      - `serializeAllEditNodesAsJSON()`
      - `serializeEditNodesAsJSON(com.smartgwt.client.tools.EditNode[])`

  - ### addPaletteNodesFromJSON

    public void addPaletteNodesFromJSON(String jsonString, EditNode parentNode)
    See `addPaletteNodesFromJSON()`

  - ### addPaletteNodesFromJSON

    public void addPaletteNodesFromJSON(String jsonString, EditNode parentNode, String[] globals)
    See `addPaletteNodesFromJSON()`

  - ### addPaletteNodesFromJSON

    public void addPaletteNodesFromJSON(String jsonString, EditNode parentNode, String[] globals, Function callback)
    Recreate `EditNodes` from a JSON representation of `PaletteNodes` (possibly created by calling `serializeAllEditNodesAsJSON()` or `serializeEditNodesAsJSON()`.

    By default, components that have `global IDs` will not actually be allowed to take those global IDs - instead, only widgets that have one of the global IDs passed as the `globals` parameter will actually receive their global IDs. To override this behavior, pass the special value `ALL_GLOBALS` for the `globals` parameter.

    Parameters:
      `jsonString` - JSON string representing an array of PaletteNodes
      `parentNode` - parent to add to (defaults to the root)
      `globals` - widgets to allow to take their global IDs
      `callback` - Callback to fire after nodes have been added
    See Also:
      - `addFromPaletteNodes(com.smartgwt.client.tools.PaletteNode[])`
      - `serializeAllEditNodesAsJSON()`
      - `serializeEditNodesAsJSON(com.smartgwt.client.tools.EditNode[])`

  - ### addPaletteNodesFromXML

    public void addPaletteNodesFromXML(String xmlString)
    Recreate `EditNodes` from an XML representation of `PaletteNodes` (possibly created by calling `serializeAllEditNodes()` or `serializeEditNodes()`.

    By default, components that have `global IDs` will not actually be allowed to take those global IDs - instead, only widgets that have one of the global IDs passed as the `globals` parameter will actually receive their global IDs. To override this behavior, pass the special value `ALL_GLOBALS` for the `globals` parameter.

    Parameters:
      `xmlString` - XML string
    See Also:
      - `serializeAllEditNodes()`
      - `serializeEditNodes(com.smartgwt.client.tools.EditNode[])`

  - ### addPaletteNodesFromXML

    public void addPaletteNodesFromXML(String xmlString, EditNode parentNode)
    See `addPaletteNodesFromXML()`

  - ### addPaletteNodesFromXML

    public void addPaletteNodesFromXML(String xmlString, EditNode parentNode, String[] globals)
    See `addPaletteNodesFromXML()`

  - ### addPaletteNodesFromXML

    public void addPaletteNodesFromXML(String xmlString, EditNode parentNode, String[] globals, Function callback)
    Recreate `EditNodes` from an XML representation of `PaletteNodes` (possibly created by calling `serializeAllEditNodes()` or `serializeEditNodes()`.

    By default, components that have `global IDs` will not actually be allowed to take those global IDs - instead, only widgets that have one of the global IDs passed as the `globals` parameter will actually receive their global IDs. To override this behavior, pass the special value `ALL_GLOBALS` for the `globals` parameter.

    Parameters:
      `xmlString` - XML string
      `parentNode` - parent node (defaults to the root)
      `globals` - widgets to allow to take their global IDs
      `callback` - Callback to fire after nodes have been added
    See Also:
      - `serializeAllEditNodes()`
      - `serializeEditNodes(com.smartgwt.client.tools.EditNode[])`

  - ### copyEditNodes

    public void copyEditNodes(EditNode editNode)
    Copies the passed editNode or editNodes to an internal "clipboard" space, for later application via `pasteEditNodes()`.
    Parameters:
      `editNode` -

  - ### copyEditNodes

    public void copyEditNodes(EditNode... editNode)
    Copies the passed editNode or editNodes to an internal "clipboard" space, for later application via `pasteEditNodes()`.
    Parameters:
      `editNode` -

  - ### destroyAll

    public void destroyAll()
    Removes all `EditNodes` from the EditContext, and calls `destroy()` on the `liveObjects`.

  - ### enableEditing

    public void enableEditing(EditNode editNode)
    Enable edit mode for an `EditNode`. This is a shortcut for calling `Canvas.setEditMode()`.
    Parameters:
      `editNode` - the EditNode on which to enable editing
    See Also:
      - `Canvas.setEditMode(boolean)`
      - `isNodeEditingOn(com.smartgwt.client.tools.EditNode)`

  - ### getEditNodeTree

    public Tree getEditNodeTree()
    Gets the tree of editNodes being edited by this editContext. Standard tree traversal methods can then be used to locate desired editNodes for interaction.

    Note: the returned tree is read-only and must only be modified by calling methods on EditContext like `EditContext.addNode()` or `EditContext.setNodeProperties()`.

    Returns:
      the tree of EditNodes

  - ### getNodeProperty

    public void getNodeProperty(EditNode editNode, String name)
    Returns the specified property from the editNode's serializable "defaults".
    Parameters:
      `editNode` - the editNode to query
      `name` - the property name to query
    See Also:
      - `setNodeProperties(com.smartgwt.client.tools.EditNode, com.smartgwt.client.widgets.Canvas)`

  - ### getPaletteNodesFromJS

    public void getPaletteNodesFromJS(String jsCode, PaletteNodeCallback callback)
    Obtain `PaletteNodes` from a JavaScript source representation.

    By default, components that have `global IDs` will not actually be allowed to take those global IDs - instead, only widgets that have one of the global IDs passed as the `globals` parameter will actually receive their global IDs. To override this behavior, pass the special value `ALL_GLOBALS` for the `globals` parameter.

    Parameters:
      `jsCode` - JavaScript code to eval.
      `callback` - Callback used to return the PaletteNodes

  - ### getPaletteNodesFromJS

    public void getPaletteNodesFromJS(String jsCode, PaletteNodeCallback callback, String[] globals)
    Obtain `PaletteNodes` from a JavaScript source representation.

    By default, components that have `global IDs` will not actually be allowed to take those global IDs - instead, only widgets that have one of the global IDs passed as the `globals` parameter will actually receive their global IDs. To override this behavior, pass the special value `ALL_GLOBALS` for the `globals` parameter.

    Parameters:
      `jsCode` - JavaScript code to eval.
      `callback` - Callback used to return the PaletteNodes
      `globals` - widgets to allow to take their global IDs

  - ### getPaletteNodesFromXML

    public void getPaletteNodesFromXML(String xmlString, PaletteNodeCallback callback)
    Obtain `PaletteNodes` from an XML representation, but do not add them to the EditContext.
    Parameters:
      `xmlString` - XML string
      `callback` - Callback used to return the PaletteNodes
    See Also:
      - `serializeAllEditNodes()`
      - `serializeEditNodes(com.smartgwt.client.tools.EditNode[])`

  - ### getRootEditNode

    public EditNode getRootEditNode()
    Returns the root `EditNode` of the EditContext typically created from `rootComponent`.
    Returns:
      the root EditNode

  - ### isNodeEditingOn

    public boolean isNodeEditingOn(EditNode editNode)
    Returns true if `editNode` is in edit mode.
    Parameters:
      `editNode` - the EditNode
    Returns:
      true if node is in edit mode

  - ### makeEditNode

    public EditNode makeEditNode(PaletteNode paletteNode)
    Creates and returns an EditNode using the `defaultPalette`. Does not add the newly created EditNode to an EditContext.
    Parameters:
      `paletteNode` - the palette node to use to create the new node
    Returns:
      the EditNode created from the paletteNode

  - ### makePaletteNode

    public PaletteNode makePaletteNode(EditNode editNode)
    Creates a `PaletteNode` from an `EditNode` in this context's `editNodeTree`.

    This essentially creates a new `PaletteNode` with the `EditNode.defaults` from the passed `editNode`. The returned `paletteNode` could then be used with `EditContext.addFromPaletteNode()` to effectively create a copy of the original editNode - specifically a new editNode with a new `EditNode.liveObject` created from the same defaults.

    However note that `makePaletteNode()` does not copy descendant nodes - use `makePaletteNodeTree()` for that.

    May return null if the passed editNode cannot validly by transformed into a paletteNode, for example if `EditNode.canDuplicate` was set false.

    Parameters:
      `editNode` - the editNode to use to make a paletteNode
    Returns:
      paletteNode derived from the editNode or null

  - ### makePaletteNodeTree

    public Tree makePaletteNodeTree(EditNode editNode, Boolean removeAutoIDs)
    Creates a `Tree` of `PaletteNodes` from an `EditNode` in this context's `editNodeTree`, by using `makePaletteNode()` on the passed `EditNode` and its descendents within the `editNodeTree`.

    The root node of the returned `Tree` will be a PaletteNode derived from the passed `EditNode`.

    Parameters:
      `editNode` - root editNode to make Tree of PaletteNodes from
      `removeAutoIDs` - should ID and autoID defaults be removed?
    Returns:
      a Tree of paletteNodes or null

  - ### pasteEditNodes

    public void pasteEditNodes()
    "Pastes" `editNodes` previously captured via `copyEditNodes()`.

    New editNodes will be added as root-level nodes of the `editNodeTree` unless a `targetEditNode` is passed.

  - ### pasteEditNodes

    public void pasteEditNodes(EditNode targetEditNode)
    "Pastes" `editNodes` previously captured via `copyEditNodes()`.

    New editNodes will be added as root-level nodes of the `editNodeTree` unless a `targetEditNode` is passed.

    Parameters:
      `targetEditNode` -

  - ### removeAll

    public void removeAll()
    Removes all `EditNodes` from the EditContext, but does not destroy the `liveObjects`.

  - ### removeNode

    public void removeNode(EditNode editNode)
    Removes `EditNode` from the EditContext. The editNode liveObject is not destroyed.
    Parameters:
      `editNode` - node to be removed

  - ### removeNodeProperties

    public void removeNodeProperties(EditNode editNode, String[] properties)
    Removes the specified properties from an editNode's serializable "defaults". Note that the `liveObject` is not updated by this method. To set a property to null (rather than removing it), use `setNodeProperties()` instead.
    Parameters:
      `editNode` - the editNode to update
      `properties` - an array of property names to remove
    See Also:
      - `setNodeProperties(com.smartgwt.client.tools.EditNode, com.smartgwt.client.widgets.Canvas)`

  - ### reorderNode

    public void reorderNode(EditNode parentNode, Integer index, Integer moveToIndex)
    Moves an `EditNode` from one child index to another in the EditContext under the specified parent.

    No changes are made to the live objects.

    Parameters:
      `parentNode` - parent to reorder child nodes
      `index` - index within the parent's children array to be moved
      `moveToIndex` - index within the parent's children array at which to place moved node

  - ### serializeAllEditNodes

    public String serializeAllEditNodes()
    Serialize the tree of `EditNodes` to an XML representation of `PaletteNodes`. The result can be supplied to `addPaletteNodesFromXML()` to recreate the EditNodes.
    Returns:
      an XML representation of PaletteNodes which can be used to recreate the tree of EditNodes.
    See Also:
      - `addPaletteNodesFromXML(java.lang.String)`

  - ### serializeAllEditNodes

    public String serializeAllEditNodes(SerializationSettings settings)
    Serialize the tree of `EditNodes` to an XML representation of `PaletteNodes`. The result can be supplied to `addPaletteNodesFromXML()` to recreate the EditNodes.
    Parameters:
      `settings` - Additional serialization settings
    Returns:
      an XML representation of PaletteNodes which can be used to recreate the tree of EditNodes.
    See Also:
      - `addPaletteNodesFromXML(java.lang.String)`

  - ### serializeAllEditNodesAsJSON

    public String serializeAllEditNodesAsJSON()
    Encode the tree of `EditNodes` to a JSON representation of `PaletteNodes`. The result can be supplied to `addPaletteNodesFromJSON()` to recreate the EditNodes.
    Returns:
      a JSON representation of PaletteNodes which can be used to recreate the tree of EditNodes.
    See Also:
      - `addPaletteNodesFromJSON(java.lang.String)`

  - ### serializeAllEditNodesAsJSON

    public String serializeAllEditNodesAsJSON(SerializationSettings settings)
    Encode the tree of `EditNodes` to a JSON representation of `PaletteNodes`. The result can be supplied to `addPaletteNodesFromJSON()` to recreate the EditNodes.
    Parameters:
      `settings` - Additional serialization settings
    Returns:
      a JSON representation of PaletteNodes which can be used to recreate the tree of EditNodes.
    See Also:
      - `addPaletteNodesFromJSON(java.lang.String)`

  - ### serializeEditNodes

    public String serializeEditNodes(EditNode[] nodes)
    Serialize the provided `EditNodes` to an XML representation of `PaletteNodes`. Note that the EditNodes must have been added to this EditContext. The result can be supplied to `addPaletteNodesFromXML()` to recreate the EditNodes.
    Parameters:
      `nodes` - EditNodes to be serialized
    Returns:
      an XML representtion of the provided EditNodes

  - ### serializeEditNodes

    public String serializeEditNodes(EditNode[] nodes, SerializationSettings settings)
    Serialize the provided `EditNodes` to an XML representation of `PaletteNodes`. Note that the EditNodes must have been added to this EditContext. The result can be supplied to `addPaletteNodesFromXML()` to recreate the EditNodes.
    Parameters:
      `nodes` - EditNodes to be serialized
      `settings` - Additional serialization settings
    Returns:
      an XML representtion of the provided EditNodes

  - ### serializeEditNodesAsJSON

    public String serializeEditNodesAsJSON(EditNode[] nodes)
    Serialize the provided `EditNodes` to a JSON representation of `PaletteNodes`. Note that the EditNodes must have been added to this EditContext. The result can be supplied to `addPaletteNodesFromJSON()` to recreate the EditNodes.
    Parameters:
      `nodes` - EditNodes to be serialized
    Returns:
      a JSON representtion of the provided EditNodes

  - ### serializeEditNodesAsJSON

    public String serializeEditNodesAsJSON(EditNode[] nodes, SerializationSettings settings)
    Serialize the provided `EditNodes` to a JSON representation of `PaletteNodes`. Note that the EditNodes must have been added to this EditContext. The result can be supplied to `addPaletteNodesFromJSON()` to recreate the EditNodes.
    Parameters:
      `nodes` - EditNodes to be serialized
      `settings` - Additional serialization settings
    Returns:
      a JSON representtion of the provided EditNodes

  - ### setNodeProperties

    public void setNodeProperties(EditNode editNode, Canvas properties)
    Update an editNode's serializable "defaults" with the supplied properties. If you wish to remove a property from the defaults (rather than setting it to null), then use `removeNodeProperties()` instead.
    Parameters:
      `editNode` - the editNode to update
      `properties` - the properties to apply
    See Also:
      - `removeNodeProperties(com.smartgwt.client.tools.EditNode, java.lang.String[])`
      - `getNodeProperty(com.smartgwt.client.tools.EditNode, java.lang.String)`

  - ### setNodeProperties

    public void setNodeProperties(EditNode editNode, Canvas properties, Boolean skipLiveObjectUpdate)
    Update an editNode's serializable "defaults" with the supplied properties. If you wish to remove a property from the defaults (rather than setting it to null), then use `removeNodeProperties()` instead.
    Parameters:
      `editNode` - the editNode to update
      `properties` - the properties to apply
      `skipLiveObjectUpdate` - whether to skip updating the `liveObject`, e.g. if you have already updated the liveObject
    See Also:
      - `removeNodeProperties(com.smartgwt.client.tools.EditNode, java.lang.String[])`
      - `getNodeProperty(com.smartgwt.client.tools.EditNode, java.lang.String)`

  - ### setDefaultProperties

    public static void setDefaultProperties(EditTree editTreeProperties)
    Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

    Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

    Parameters:
      `editTreeProperties` - properties that should be used as new defaults when instances of this class are created
    See Also:
      - `SGWTProperties`

  - ### setLogicalStructure

    public LogicalStructureObject setLogicalStructure(EditTreeLogicalStructure s)
    Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.

  - ### getLogicalStructure

    public LogicalStructureObject getLogicalStructure()
    Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    Specified by:
      `getLogicalStructure` in interface `LogicalStructure`
    Overrides:
      `getLogicalStructure` in class `TreeGrid`